/* Surface.c generated by valac 0.42.7, the Vala compiler
 * generated from Surface.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/


#include <glib.h>
#include <glib-object.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <string.h>


#define PLANK_TYPE_SURFACE (plank_surface_get_type ())
#define PLANK_SURFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_SURFACE, PlankSurface))
#define PLANK_SURFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_SURFACE, PlankSurfaceClass))
#define PLANK_IS_SURFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_SURFACE))
#define PLANK_IS_SURFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_SURFACE))
#define PLANK_SURFACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_SURFACE, PlankSurfaceClass))

typedef struct _PlankSurface PlankSurface;
typedef struct _PlankSurfaceClass PlankSurfaceClass;
typedef struct _PlankSurfacePrivate PlankSurfacePrivate;
enum  {
	PLANK_SURFACE_0_PROPERTY,
	PLANK_SURFACE_INTERNAL_PROPERTY,
	PLANK_SURFACE_WIDTH_PROPERTY,
	PLANK_SURFACE_HEIGHT_PROPERTY,
	PLANK_SURFACE_CONTEXT_PROPERTY,
	PLANK_SURFACE_NUM_PROPERTIES
};
static GParamSpec* plank_surface_properties[PLANK_SURFACE_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define PLANK_TYPE_COLOR (plank_color_get_type ())
typedef GdkRGBA PlankColor;
typedef struct _Block5Data Block5Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PlankSurface {
	GObject parent_instance;
	PlankSurfacePrivate * priv;
};

struct _PlankSurfaceClass {
	GObjectClass parent_class;
};

struct _PlankSurfacePrivate {
	cairo_surface_t* _Internal;
	gint _Width;
	gint _Height;
	cairo_t* _Context;
};

struct _Block5Data {
	int _ref_count_;
	PlankSurface* self;
	gint alpha;
	gint height;
	gint width;
	guint8* pixels;
};

struct _Block6Data {
	int _ref_count_;
	PlankSurface* self;
	gint gaussWidth;
	gdouble* kernel;
	gint kernel_length1;
	gint _kernel_size_;
	gint width;
	gint height;
	gdouble* abuffer;
	gint abuffer_length1;
	gint _abuffer_size_;
	gdouble* bbuffer;
	gint bbuffer_length1;
	gint _bbuffer_size_;
	gint* shiftar;
	gint shiftar_length1;
	gint shiftar_length2;
	gint _shiftar_size_;
};


static gint PlankSurface_private_offset;
static gpointer plank_surface_parent_class = NULL;

GType plank_surface_get_type (void) G_GNUC_CONST;
#define PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION 16
#define PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION 7
PlankSurface* plank_surface_new (gint width,
                                 gint height);
PlankSurface* plank_surface_construct (GType object_type,
                                       gint width,
                                       gint height);
PlankSurface* plank_surface_new_with_cairo_surface (gint width,
                                                    gint height,
                                                    cairo_surface_t* model);
PlankSurface* plank_surface_construct_with_cairo_surface (GType object_type,
                                                          gint width,
                                                          gint height,
                                                          cairo_surface_t* model);
PlankSurface* plank_surface_new_with_surface (gint width,
                                              gint height,
                                              PlankSurface* model);
PlankSurface* plank_surface_construct_with_surface (GType object_type,
                                                    gint width,
                                                    gint height,
                                                    PlankSurface* model);
cairo_surface_t* plank_surface_get_Internal (PlankSurface* self);
PlankSurface* plank_surface_new_with_internal (cairo_surface_t* image);
PlankSurface* plank_surface_construct_with_internal (GType object_type,
                                                     cairo_surface_t* image);
void plank_surface_clear (PlankSurface* self);
cairo_t* plank_surface_get_Context (PlankSurface* self);
PlankSurface* plank_surface_copy (PlankSurface* self);
gint plank_surface_get_Width (PlankSurface* self);
gint plank_surface_get_Height (PlankSurface* self);
PlankSurface* plank_surface_scaled_copy (PlankSurface* self,
                                         gint width,
                                         gint height);
GdkPixbuf* plank_surface_to_pixbuf (PlankSurface* self);
PlankSurface* plank_surface_create_mask (PlankSurface* self,
                                         gdouble threshold,
                                         GdkRectangle* extent);
GType plank_color_get_type (void) G_GNUC_CONST;
PlankColor* plank_color_dup (const PlankColor* self);
void plank_color_free (PlankColor* self);
void plank_surface_average_color (PlankSurface* self,
                                  PlankColor* result);
void plank_drawing_service_average_color (GdkPixbuf* source,
                                          PlankColor* result);
void plank_surface_fast_blur (PlankSurface* self,
                              gint radius,
                              gint process_count);
void plank_surface_exponential_blur (PlankSurface* self,
                                     gint radius);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void* __lambda4_ (Block5Data* _data5_);
static void plank_surface_exponential_blur_rows (guint8* pixels,
                                          gint width,
                                          gint height,
                                          gint startRow,
                                          gint endRow,
                                          gint startX,
                                          gint endX,
                                          gint alpha);
static gpointer ___lambda4__gthread_func (gpointer self);
static void* __lambda5_ (Block5Data* _data5_);
static void plank_surface_exponential_blur_columns (guint8* pixels,
                                             gint width,
                                             gint height,
                                             gint startCol,
                                             gint endCol,
                                             gint startY,
                                             gint endY,
                                             gint alpha);
static gpointer ___lambda5__gthread_func (gpointer self);
static inline void plank_surface_exponential_blur_inner (guint8* pixel,
                                           gint* zA,
                                           gint* zR,
                                           gint* zG,
                                           gint* zB,
                                           gint alpha);
void plank_surface_gaussian_blur (PlankSurface* self,
                                  gint radius);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gdouble* plank_surface_build_gaussian_kernel (gint gaussWidth,
                                              int* result_length1);
static void* __lambda6_ (Block6Data* _data6_);
static void plank_surface_gaussian_blur_horizontal (gdouble* src,
                                             gdouble* dest,
                                             gdouble* kernel,
                                             gint gaussWidth,
                                             gint width,
                                             gint height,
                                             gint startRow,
                                             gint endRow,
                                             gint* shift,
                                             int shift_length1,
                                             int shift_length2);
static gpointer ___lambda6__gthread_func (gpointer self);
static void* __lambda7_ (Block6Data* _data6_);
static void plank_surface_gaussian_blur_vertical (gdouble* src,
                                           gdouble* dest,
                                           gdouble* kernel,
                                           gint gaussWidth,
                                           gint width,
                                           gint height,
                                           gint startCol,
                                           gint endCol,
                                           gint* shift,
                                           int shift_length1,
                                           int shift_length2);
static gpointer ___lambda7__gthread_func (gpointer self);
static void plank_surface_set_Internal (PlankSurface* self,
                                 cairo_surface_t* value);
static void plank_surface_set_Width (PlankSurface* self,
                              gint value);
static void plank_surface_set_Height (PlankSurface* self,
                               gint value);
static void plank_surface_set_Context (PlankSurface* self,
                                cairo_t* value);
static GObject * plank_surface_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void plank_surface_finalize (GObject * obj);
static void _vala_plank_surface_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_plank_surface_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);


static inline gpointer
plank_surface_get_instance_private (PlankSurface* self)
{
	return G_STRUCT_MEMBER_P (self, PlankSurface_private_offset);
}


/**
 * Creates a new surface.
 *
 * @param width width of the new surface
 * @param height height of the new surface
 */
PlankSurface*
plank_surface_construct (GType object_type,
                         gint width,
                         gint height)
{
	PlankSurface * self = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	_tmp0_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
	_tmp1_ = _tmp0_;
	self = (PlankSurface*) g_object_new (object_type, "Width", width, "Height", height, "Internal", _tmp1_, NULL);
	_cairo_surface_destroy0 (_tmp1_);
	return self;
}


PlankSurface*
plank_surface_new (gint width,
                   gint height)
{
	return plank_surface_construct (PLANK_TYPE_SURFACE, width, height);
}


/**
 * Creates a new surface compatible with an existing {@link Cairo.Surface}.
 *
 * @param width width of the new surface
 * @param height height of the new surface
 * @param model existing {@link Cairo.Surface} to be similar to
 */
PlankSurface*
plank_surface_construct_with_cairo_surface (GType object_type,
                                            gint width,
                                            gint height,
                                            cairo_surface_t* model)
{
	PlankSurface * self = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	g_return_val_if_fail (model != NULL, NULL);
	_tmp0_ = cairo_surface_create_similar (model, CAIRO_CONTENT_COLOR_ALPHA, width, height);
	_tmp1_ = _tmp0_;
	self = (PlankSurface*) g_object_new (object_type, "Width", width, "Height", height, "Internal", _tmp1_, NULL);
	_cairo_surface_destroy0 (_tmp1_);
	return self;
}


PlankSurface*
plank_surface_new_with_cairo_surface (gint width,
                                      gint height,
                                      cairo_surface_t* model)
{
	return plank_surface_construct_with_cairo_surface (PLANK_TYPE_SURFACE, width, height, model);
}


/**
 * Creates a new surface compatible with an existing {@link Surface}.
 *
 * @param width width of the new surface
 * @param height height of the new surface
 * @param model existing {@link Surface} to be similar to
 */
PlankSurface*
plank_surface_construct_with_surface (GType object_type,
                                      gint width,
                                      gint height,
                                      PlankSurface* model)
{
	PlankSurface * self = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp2_;
	g_return_val_if_fail (model != NULL, NULL);
	_tmp0_ = model->priv->_Internal;
	_tmp1_ = cairo_surface_create_similar (_tmp0_, CAIRO_CONTENT_COLOR_ALPHA, width, height);
	_tmp2_ = _tmp1_;
	self = (PlankSurface*) g_object_new (object_type, "Width", width, "Height", height, "Internal", _tmp2_, NULL);
	_cairo_surface_destroy0 (_tmp2_);
	return self;
}


PlankSurface*
plank_surface_new_with_surface (gint width,
                                gint height,
                                PlankSurface* model)
{
	return plank_surface_construct_with_surface (PLANK_TYPE_SURFACE, width, height, model);
}


/**
 * Creates a new surface with the given {@link Cairo.ImageSurface} as Internal.
 *
 * @param image existing {@link Cairo.ImageSurface} as Internal
 */
PlankSurface*
plank_surface_construct_with_internal (GType object_type,
                                       cairo_surface_t* image)
{
	PlankSurface * self = NULL;
	g_return_val_if_fail (image != NULL, NULL);
	self = (PlankSurface*) g_object_new (object_type, "Width", cairo_image_surface_get_width (image), "Height", cairo_image_surface_get_height (image), "Internal", image, NULL);
	return self;
}


PlankSurface*
plank_surface_new_with_internal (cairo_surface_t* image)
{
	return plank_surface_construct_with_internal (PLANK_TYPE_SURFACE, image);
}


/**
 * Clears the entire surface.
 */
void
plank_surface_clear (PlankSurface* self)
{
	cairo_t* cr = NULL;
	cairo_t* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_Context;
	cr = _tmp0_;
	cairo_save (cr);
	cairo_set_operator (cr, CAIRO_OPERATOR_CLEAR);
	cairo_paint (cr);
	cairo_restore (cr);
}


/**
 * Create a copy of the surface
 *
 * @return copy of this surface
 */
PlankSurface*
plank_surface_copy (PlankSurface* self)
{
	PlankSurface* result = NULL;
	PlankSurface* copy = NULL;
	gint _tmp0_;
	gint _tmp1_;
	PlankSurface* _tmp2_;
	cairo_t* cr = NULL;
	cairo_t* _tmp3_;
	cairo_surface_t* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Width;
	_tmp1_ = self->priv->_Height;
	_tmp2_ = plank_surface_new_with_surface (_tmp0_, _tmp1_, self);
	copy = _tmp2_;
	_tmp3_ = copy->priv->_Context;
	cr = _tmp3_;
	_tmp4_ = self->priv->_Internal;
	cairo_set_source_surface (cr, _tmp4_, (gdouble) 0, (gdouble) 0);
	cairo_paint (cr);
	result = copy;
	return result;
}


/**
 * Create a scaled copy of the surface
 *
 * @param width the resulting width
 * @param height the resulting height
 * @return scaled copy of this surface
 */
PlankSurface*
plank_surface_scaled_copy (PlankSurface* self,
                           gint width,
                           gint height)
{
	PlankSurface* result = NULL;
	PlankSurface* _result_ = NULL;
	PlankSurface* _tmp0_;
	cairo_t* cr = NULL;
	cairo_t* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	cairo_surface_t* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = plank_surface_new_with_surface (width, height, self);
	_result_ = _tmp0_;
	_tmp1_ = _result_->priv->_Context;
	cr = _tmp1_;
	cairo_save (cr);
	_tmp2_ = self->priv->_Width;
	_tmp3_ = self->priv->_Height;
	cairo_scale (cr, ((gdouble) width) / _tmp2_, ((gdouble) height) / _tmp3_);
	_tmp4_ = self->priv->_Internal;
	cairo_set_source_surface (cr, _tmp4_, (gdouble) 0, (gdouble) 0);
	cairo_paint (cr);
	cairo_restore (cr);
	result = _result_;
	return result;
}


/**
 * Saves the current surface to a {@link Gdk.Pixbuf}.
 *
 * @return the {@link Gdk.Pixbuf}
 */
GdkPixbuf*
plank_surface_to_pixbuf (PlankSurface* self)
{
	GdkPixbuf* result = NULL;
	cairo_surface_t* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkPixbuf* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Internal;
	_tmp1_ = self->priv->_Width;
	_tmp2_ = self->priv->_Height;
	_tmp3_ = gdk_pixbuf_get_from_surface (_tmp0_, 0, 0, _tmp1_, _tmp2_);
	result = _tmp3_;
	return result;
}


/**
 * Computes the mask of the surface.
 *
 * @param threshold value defining the minimum opacity [0.0 .. 1.0]
 * @param extent bounding box of the found mask
 * @return a new surface containing the mask
 */
PlankSurface*
plank_surface_create_mask (PlankSurface* self,
                           gdouble threshold,
                           GdkRectangle* extent)
{
	GdkRectangle _vala_extent = {0};
	PlankSurface* result = NULL;
	cairo_surface_t* surface = NULL;
	gint _tmp0_;
	gint _tmp1_;
	cairo_surface_t* _tmp2_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp3_;
	cairo_t* _tmp4_;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	cairo_t* _tmp8_;
	gint w = 0;
	cairo_surface_t* _tmp9_;
	gint h = 0;
	cairo_surface_t* _tmp10_;
	guint8 slice = 0U;
	gint left = 0;
	gint _tmp11_;
	gint right = 0;
	gint top = 0;
	gint _tmp12_;
	gint bottom = 0;
	guint8* data = NULL;
	cairo_surface_t* _tmp13_;
	guchar* _tmp14_;
	gint src = 0;
	gboolean mask = FALSE;
	gint _tmp53_;
	gint _tmp54_;
	gint _tmp55_;
	gint _tmp56_;
	gint _tmp57_;
	gint _tmp58_;
	GdkRectangle _tmp59_ = {0};
	cairo_surface_t* _tmp60_;
	PlankSurface* _tmp61_;
	g_return_val_if_fail (self != NULL, NULL);
	_vala_return_val_if_fail ((threshold >= 0.0) && (threshold <= 1.0), "threshold >= 0.0 && threshold <= 1.0", NULL);
	_tmp0_ = self->priv->_Width;
	_tmp1_ = self->priv->_Height;
	_tmp2_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp0_, _tmp1_);
	surface = _tmp2_;
	_tmp3_ = surface;
	_tmp4_ = cairo_create (_tmp3_);
	cr = _tmp4_;
	_tmp5_ = cr;
	cairo_set_operator (_tmp5_, CAIRO_OPERATOR_SOURCE);
	_tmp6_ = cr;
	_tmp7_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp6_, _tmp7_, (gdouble) 0, (gdouble) 0);
	_tmp8_ = cr;
	cairo_paint (_tmp8_);
	_tmp9_ = surface;
	w = cairo_image_surface_get_width (_tmp9_);
	_tmp10_ = surface;
	h = cairo_image_surface_get_height (_tmp10_);
	slice = (guint8) (G_MAXUINT8 * threshold);
	_tmp11_ = w;
	left = _tmp11_;
	right = 0;
	_tmp12_ = h;
	top = _tmp12_;
	bottom = 0;
	_tmp13_ = surface;
	_tmp14_ = cairo_image_surface_get_data (_tmp13_);
	data = _tmp14_;
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp15_ = FALSE;
			_tmp15_ = TRUE;
			while (TRUE) {
				gint _tmp17_;
				gint _tmp18_;
				if (!_tmp15_) {
					gint _tmp16_;
					_tmp16_ = y;
					y = _tmp16_ + 1;
				}
				_tmp15_ = FALSE;
				_tmp17_ = y;
				_tmp18_ = h;
				if (!(_tmp17_ < _tmp18_)) {
					break;
				}
				{
					gint x = 0;
					x = 0;
					{
						gboolean _tmp19_ = FALSE;
						_tmp19_ = TRUE;
						while (TRUE) {
							gint _tmp21_;
							gint _tmp22_;
							gint _tmp23_;
							gint _tmp24_;
							gint _tmp25_;
							guint8* _tmp26_;
							gint _tmp27_;
							guint8 _tmp28_;
							guint8 _tmp29_;
							guint8* _tmp30_;
							gint _tmp31_;
							guint8* _tmp32_;
							gint _tmp33_;
							guint8* _tmp34_;
							gint _tmp35_;
							guint8 _tmp36_ = 0U;
							gboolean _tmp37_;
							guint8* _tmp38_;
							gint _tmp39_;
							gboolean _tmp40_;
							if (!_tmp19_) {
								gint _tmp20_;
								_tmp20_ = x;
								x = _tmp20_ + 1;
							}
							_tmp19_ = FALSE;
							_tmp21_ = x;
							_tmp22_ = w;
							if (!(_tmp21_ < _tmp22_)) {
								break;
							}
							_tmp23_ = y;
							_tmp24_ = w;
							_tmp25_ = x;
							src = ((_tmp23_ * _tmp24_) + _tmp25_) * 4;
							_tmp26_ = data;
							_tmp27_ = src;
							_tmp28_ = _tmp26_[_tmp27_ + 3];
							_tmp29_ = slice;
							mask = _tmp28_ > _tmp29_;
							_tmp30_ = data;
							_tmp31_ = src;
							_tmp30_[_tmp31_ + 0] = (guint8) 0;
							_tmp32_ = data;
							_tmp33_ = src;
							_tmp32_[_tmp33_ + 1] = (guint8) 0;
							_tmp34_ = data;
							_tmp35_ = src;
							_tmp34_[_tmp35_ + 2] = (guint8) 0;
							_tmp37_ = mask;
							if (_tmp37_) {
								_tmp36_ = G_MAXUINT8;
							} else {
								_tmp36_ = (guint8) 0;
							}
							_tmp38_ = data;
							_tmp39_ = src;
							_tmp38_[_tmp39_ + 3] = _tmp36_;
							_tmp40_ = mask;
							if (_tmp40_) {
								gint _tmp41_;
								gint _tmp42_;
								gint _tmp44_;
								gint _tmp45_;
								gint _tmp47_;
								gint _tmp48_;
								gint _tmp50_;
								gint _tmp51_;
								_tmp41_ = y;
								_tmp42_ = top;
								if (_tmp41_ < _tmp42_) {
									gint _tmp43_;
									_tmp43_ = y;
									top = _tmp43_;
								}
								_tmp44_ = y;
								_tmp45_ = bottom;
								if (_tmp44_ > _tmp45_) {
									gint _tmp46_;
									_tmp46_ = y;
									bottom = _tmp46_;
								}
								_tmp47_ = x;
								_tmp48_ = left;
								if (_tmp47_ < _tmp48_) {
									gint _tmp49_;
									_tmp49_ = x;
									left = _tmp49_;
								}
								_tmp50_ = x;
								_tmp51_ = right;
								if (_tmp50_ > _tmp51_) {
									gint _tmp52_;
									_tmp52_ = x;
									right = _tmp52_;
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp53_ = left;
	_tmp54_ = top;
	_tmp55_ = right;
	_tmp56_ = left;
	_tmp57_ = bottom;
	_tmp58_ = top;
	_tmp59_.x = _tmp53_;
	_tmp59_.y = _tmp54_;
	_tmp59_.width = _tmp55_ - _tmp56_;
	_tmp59_.height = _tmp57_ - _tmp58_;
	_vala_extent = _tmp59_;
	_tmp60_ = surface;
	_tmp61_ = plank_surface_new_with_internal (_tmp60_);
	result = _tmp61_;
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (surface);
	if (extent) {
		*extent = _vala_extent;
	}
	return result;
}


/**
 * Computes and returns the average color of the surface.
 *
 * @return the average color of the surface
 */
void
plank_surface_average_color (PlankSurface* self,
                             PlankColor* result)
{
	cairo_surface_t* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	PlankColor _tmp5_ = {0};
	PlankColor _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_Internal;
	_tmp1_ = self->priv->_Width;
	_tmp2_ = self->priv->_Height;
	_tmp3_ = gdk_pixbuf_get_from_surface (_tmp0_, 0, 0, _tmp1_, _tmp2_);
	_tmp4_ = _tmp3_;
	plank_drawing_service_average_color (_tmp4_, &_tmp5_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp4_);
	*result = _tmp6_;
	return;
}


/**
 * Performs a fast blur on the surface.
 *
 * @param radius the radius of the blur
 * @param process_count how many iterations to blur
 */
void
plank_surface_fast_blur (PlankSurface* self,
                         gint radius,
                         gint process_count)
{
	gboolean _tmp0_ = FALSE;
	gint w = 0;
	gint _tmp1_;
	gint h = 0;
	gint _tmp2_;
	gint channels = 0;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_;
	cairo_surface_t* original = NULL;
	gint _tmp6_;
	gint _tmp7_;
	cairo_surface_t* _tmp8_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	cairo_surface_t* _tmp13_;
	cairo_t* _tmp14_;
	guint8* pixels = NULL;
	cairo_surface_t* _tmp15_;
	guchar* _tmp16_;
	guint8* buffer = NULL;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	guint8* _tmp20_;
	gint buffer_length1;
	gint _buffer_size_;
	gint* vmin = NULL;
	gint _tmp21_;
	gint _tmp22_;
	gint* _tmp23_;
	gint vmin_length1;
	gint _vmin_size_;
	gint* vmax = NULL;
	gint _tmp24_;
	gint _tmp25_;
	gint* _tmp26_;
	gint vmax_length1;
	gint _vmax_size_;
	gint div = 0;
	guint8* dv = NULL;
	gint _tmp27_;
	guint8* _tmp28_;
	gint dv_length1;
	gint _dv_size_;
	cairo_surface_t* _tmp286_;
	cairo_t* target_cr = NULL;
	cairo_t* _tmp287_;
	cairo_t* _tmp288_;
	cairo_t* _tmp289_;
	cairo_t* _tmp290_;
	cairo_surface_t* _tmp291_;
	cairo_t* _tmp292_;
	cairo_t* _tmp293_;
	g_return_if_fail (self != NULL);
	if (radius < 1) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = process_count < 1;
	}
	if (_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->_Width;
	w = _tmp1_;
	_tmp2_ = self->priv->_Height;
	h = _tmp2_;
	channels = 4;
	_tmp4_ = w;
	if (radius > (_tmp4_ - 1)) {
		_tmp3_ = TRUE;
	} else {
		gint _tmp5_;
		_tmp5_ = h;
		_tmp3_ = radius > (_tmp5_ - 1);
	}
	if (_tmp3_) {
		return;
	}
	_tmp6_ = w;
	_tmp7_ = h;
	_tmp8_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp6_, _tmp7_);
	original = _tmp8_;
	_tmp9_ = original;
	_tmp10_ = cairo_create (_tmp9_);
	cr = _tmp10_;
	_tmp11_ = cr;
	cairo_set_operator (_tmp11_, CAIRO_OPERATOR_SOURCE);
	_tmp12_ = cr;
	_tmp13_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp12_, _tmp13_, (gdouble) 0, (gdouble) 0);
	_tmp14_ = cr;
	cairo_paint (_tmp14_);
	_tmp15_ = original;
	_tmp16_ = cairo_image_surface_get_data (_tmp15_);
	pixels = _tmp16_;
	_tmp17_ = w;
	_tmp18_ = h;
	_tmp19_ = channels;
	_tmp20_ = g_new0 (guint8, (_tmp17_ * _tmp18_) * _tmp19_);
	buffer = _tmp20_;
	buffer_length1 = (_tmp17_ * _tmp18_) * _tmp19_;
	_buffer_size_ = buffer_length1;
	_tmp21_ = w;
	_tmp22_ = h;
	_tmp23_ = g_new0 (gint, MAX (_tmp21_, _tmp22_));
	vmin = _tmp23_;
	vmin_length1 = MAX (_tmp21_, _tmp22_);
	_vmin_size_ = vmin_length1;
	_tmp24_ = w;
	_tmp25_ = h;
	_tmp26_ = g_new0 (gint, MAX (_tmp24_, _tmp25_));
	vmax = _tmp26_;
	vmax_length1 = MAX (_tmp24_, _tmp25_);
	_vmax_size_ = vmax_length1;
	div = (2 * radius) + 1;
	_tmp27_ = div;
	_tmp28_ = g_new0 (guint8, 256 * _tmp27_);
	dv = _tmp28_;
	dv_length1 = 256 * _tmp27_;
	_dv_size_ = dv_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp29_ = FALSE;
			_tmp29_ = TRUE;
			while (TRUE) {
				gint _tmp31_;
				guint8* _tmp32_;
				gint _tmp32__length1;
				guint8* _tmp33_;
				gint _tmp33__length1;
				gint _tmp34_;
				gint _tmp35_;
				gint _tmp36_;
				if (!_tmp29_) {
					gint _tmp30_;
					_tmp30_ = i;
					i = _tmp30_ + 1;
				}
				_tmp29_ = FALSE;
				_tmp31_ = i;
				_tmp32_ = dv;
				_tmp32__length1 = dv_length1;
				if (!(_tmp31_ < _tmp32__length1)) {
					break;
				}
				_tmp33_ = dv;
				_tmp33__length1 = dv_length1;
				_tmp34_ = i;
				_tmp35_ = i;
				_tmp36_ = div;
				_tmp33_[_tmp34_] = (guint8) (_tmp35_ / _tmp36_);
			}
		}
	}
	while (TRUE) {
		gint _tmp37_;
		_tmp37_ = process_count;
		process_count = _tmp37_ - 1;
		if (!(_tmp37_ > 0)) {
			break;
		}
		{
			gint x = 0;
			x = 0;
			{
				gboolean _tmp38_ = FALSE;
				_tmp38_ = TRUE;
				while (TRUE) {
					gint _tmp40_;
					gint _tmp41_;
					gint* _tmp42_;
					gint _tmp42__length1;
					gint _tmp43_;
					gint _tmp44_;
					gint _tmp45_;
					gint* _tmp46_;
					gint _tmp46__length1;
					gint _tmp47_;
					gint _tmp48_;
					if (!_tmp38_) {
						gint _tmp39_;
						_tmp39_ = x;
						x = _tmp39_ + 1;
					}
					_tmp38_ = FALSE;
					_tmp40_ = x;
					_tmp41_ = w;
					if (!(_tmp40_ < _tmp41_)) {
						break;
					}
					_tmp42_ = vmin;
					_tmp42__length1 = vmin_length1;
					_tmp43_ = x;
					_tmp44_ = x;
					_tmp45_ = w;
					_tmp42_[_tmp43_] = MIN ((_tmp44_ + radius) + 1, _tmp45_ - 1);
					_tmp46_ = vmax;
					_tmp46__length1 = vmax_length1;
					_tmp47_ = x;
					_tmp48_ = x;
					_tmp46_[_tmp47_] = MAX (_tmp48_ - radius, 0);
				}
			}
		}
		{
			gint y = 0;
			y = 0;
			{
				gboolean _tmp49_ = FALSE;
				_tmp49_ = TRUE;
				while (TRUE) {
					gint _tmp51_;
					gint _tmp52_;
					gint asum = 0;
					gint rsum = 0;
					gint gsum = 0;
					gint bsum = 0;
					guint32 cur_pixel = 0U;
					gint _tmp53_;
					gint _tmp54_;
					gint _tmp55_;
					gint _tmp56_;
					guint8* _tmp57_;
					guint32 _tmp58_;
					guint8 _tmp59_;
					gint _tmp60_;
					guint8* _tmp61_;
					guint32 _tmp62_;
					guint8 _tmp63_;
					gint _tmp64_;
					guint8* _tmp65_;
					guint32 _tmp66_;
					guint8 _tmp67_;
					gint _tmp68_;
					guint8* _tmp69_;
					guint32 _tmp70_;
					guint8 _tmp71_;
					gint _tmp93_;
					gint _tmp94_;
					gint _tmp95_;
					if (!_tmp49_) {
						gint _tmp50_;
						_tmp50_ = y;
						y = _tmp50_ + 1;
					}
					_tmp49_ = FALSE;
					_tmp51_ = y;
					_tmp52_ = h;
					if (!(_tmp51_ < _tmp52_)) {
						break;
					}
					asum = 0;
					rsum = 0;
					gsum = 0;
					bsum = 0;
					_tmp53_ = y;
					_tmp54_ = w;
					_tmp55_ = channels;
					cur_pixel = (guint32) ((_tmp53_ * _tmp54_) * _tmp55_);
					_tmp56_ = asum;
					_tmp57_ = pixels;
					_tmp58_ = cur_pixel;
					_tmp59_ = _tmp57_[_tmp58_ + 0];
					asum = _tmp56_ + (radius * _tmp59_);
					_tmp60_ = rsum;
					_tmp61_ = pixels;
					_tmp62_ = cur_pixel;
					_tmp63_ = _tmp61_[_tmp62_ + 1];
					rsum = _tmp60_ + (radius * _tmp63_);
					_tmp64_ = gsum;
					_tmp65_ = pixels;
					_tmp66_ = cur_pixel;
					_tmp67_ = _tmp65_[_tmp66_ + 2];
					gsum = _tmp64_ + (radius * _tmp67_);
					_tmp68_ = bsum;
					_tmp69_ = pixels;
					_tmp70_ = cur_pixel;
					_tmp71_ = _tmp69_[_tmp70_ + 3];
					bsum = _tmp68_ + (radius * _tmp71_);
					{
						gint i = 0;
						i = 0;
						{
							gboolean _tmp72_ = FALSE;
							_tmp72_ = TRUE;
							while (TRUE) {
								gint _tmp74_;
								gint _tmp75_;
								guint8* _tmp76_;
								guint32 _tmp77_;
								guint8 _tmp78_;
								gint _tmp79_;
								guint8* _tmp80_;
								guint32 _tmp81_;
								guint8 _tmp82_;
								gint _tmp83_;
								guint8* _tmp84_;
								guint32 _tmp85_;
								guint8 _tmp86_;
								gint _tmp87_;
								guint8* _tmp88_;
								guint32 _tmp89_;
								guint8 _tmp90_;
								guint32 _tmp91_;
								gint _tmp92_;
								if (!_tmp72_) {
									gint _tmp73_;
									_tmp73_ = i;
									i = _tmp73_ + 1;
								}
								_tmp72_ = FALSE;
								_tmp74_ = i;
								if (!(_tmp74_ <= radius)) {
									break;
								}
								_tmp75_ = asum;
								_tmp76_ = pixels;
								_tmp77_ = cur_pixel;
								_tmp78_ = _tmp76_[_tmp77_ + 0];
								asum = _tmp75_ + _tmp78_;
								_tmp79_ = rsum;
								_tmp80_ = pixels;
								_tmp81_ = cur_pixel;
								_tmp82_ = _tmp80_[_tmp81_ + 1];
								rsum = _tmp79_ + _tmp82_;
								_tmp83_ = gsum;
								_tmp84_ = pixels;
								_tmp85_ = cur_pixel;
								_tmp86_ = _tmp84_[_tmp85_ + 2];
								gsum = _tmp83_ + _tmp86_;
								_tmp87_ = bsum;
								_tmp88_ = pixels;
								_tmp89_ = cur_pixel;
								_tmp90_ = _tmp88_[_tmp89_ + 3];
								bsum = _tmp87_ + _tmp90_;
								_tmp91_ = cur_pixel;
								_tmp92_ = channels;
								cur_pixel = _tmp91_ + _tmp92_;
							}
						}
					}
					_tmp93_ = y;
					_tmp94_ = w;
					_tmp95_ = channels;
					cur_pixel = (guint32) ((_tmp93_ * _tmp94_) * _tmp95_);
					{
						gint x = 0;
						x = 0;
						{
							gboolean _tmp96_ = FALSE;
							_tmp96_ = TRUE;
							while (TRUE) {
								gint _tmp98_;
								gint _tmp99_;
								guint32 p1 = 0U;
								gint _tmp100_;
								gint _tmp101_;
								gint* _tmp102_;
								gint _tmp102__length1;
								gint _tmp103_;
								gint _tmp104_;
								gint _tmp105_;
								guint32 p2 = 0U;
								gint _tmp106_;
								gint _tmp107_;
								gint* _tmp108_;
								gint _tmp108__length1;
								gint _tmp109_;
								gint _tmp110_;
								gint _tmp111_;
								guint8* _tmp112_;
								gint _tmp112__length1;
								guint32 _tmp113_;
								guint8* _tmp114_;
								gint _tmp114__length1;
								gint _tmp115_;
								guint8 _tmp116_;
								guint8* _tmp117_;
								gint _tmp117__length1;
								guint32 _tmp118_;
								guint8* _tmp119_;
								gint _tmp119__length1;
								gint _tmp120_;
								guint8 _tmp121_;
								guint8* _tmp122_;
								gint _tmp122__length1;
								guint32 _tmp123_;
								guint8* _tmp124_;
								gint _tmp124__length1;
								gint _tmp125_;
								guint8 _tmp126_;
								guint8* _tmp127_;
								gint _tmp127__length1;
								guint32 _tmp128_;
								guint8* _tmp129_;
								gint _tmp129__length1;
								gint _tmp130_;
								guint8 _tmp131_;
								gint _tmp132_;
								guint8* _tmp133_;
								guint32 _tmp134_;
								guint8 _tmp135_;
								guint8* _tmp136_;
								guint32 _tmp137_;
								guint8 _tmp138_;
								gint _tmp139_;
								guint8* _tmp140_;
								guint32 _tmp141_;
								guint8 _tmp142_;
								guint8* _tmp143_;
								guint32 _tmp144_;
								guint8 _tmp145_;
								gint _tmp146_;
								guint8* _tmp147_;
								guint32 _tmp148_;
								guint8 _tmp149_;
								guint8* _tmp150_;
								guint32 _tmp151_;
								guint8 _tmp152_;
								gint _tmp153_;
								guint8* _tmp154_;
								guint32 _tmp155_;
								guint8 _tmp156_;
								guint8* _tmp157_;
								guint32 _tmp158_;
								guint8 _tmp159_;
								guint32 _tmp160_;
								gint _tmp161_;
								if (!_tmp96_) {
									gint _tmp97_;
									_tmp97_ = x;
									x = _tmp97_ + 1;
								}
								_tmp96_ = FALSE;
								_tmp98_ = x;
								_tmp99_ = w;
								if (!(_tmp98_ < _tmp99_)) {
									break;
								}
								_tmp100_ = y;
								_tmp101_ = w;
								_tmp102_ = vmin;
								_tmp102__length1 = vmin_length1;
								_tmp103_ = x;
								_tmp104_ = _tmp102_[_tmp103_];
								_tmp105_ = channels;
								p1 = (guint32) (((_tmp100_ * _tmp101_) + _tmp104_) * _tmp105_);
								_tmp106_ = y;
								_tmp107_ = w;
								_tmp108_ = vmax;
								_tmp108__length1 = vmax_length1;
								_tmp109_ = x;
								_tmp110_ = _tmp108_[_tmp109_];
								_tmp111_ = channels;
								p2 = (guint32) (((_tmp106_ * _tmp107_) + _tmp110_) * _tmp111_);
								_tmp112_ = buffer;
								_tmp112__length1 = buffer_length1;
								_tmp113_ = cur_pixel;
								_tmp114_ = dv;
								_tmp114__length1 = dv_length1;
								_tmp115_ = asum;
								_tmp116_ = _tmp114_[_tmp115_];
								_tmp112_[_tmp113_ + 0] = _tmp116_;
								_tmp117_ = buffer;
								_tmp117__length1 = buffer_length1;
								_tmp118_ = cur_pixel;
								_tmp119_ = dv;
								_tmp119__length1 = dv_length1;
								_tmp120_ = rsum;
								_tmp121_ = _tmp119_[_tmp120_];
								_tmp117_[_tmp118_ + 1] = _tmp121_;
								_tmp122_ = buffer;
								_tmp122__length1 = buffer_length1;
								_tmp123_ = cur_pixel;
								_tmp124_ = dv;
								_tmp124__length1 = dv_length1;
								_tmp125_ = gsum;
								_tmp126_ = _tmp124_[_tmp125_];
								_tmp122_[_tmp123_ + 2] = _tmp126_;
								_tmp127_ = buffer;
								_tmp127__length1 = buffer_length1;
								_tmp128_ = cur_pixel;
								_tmp129_ = dv;
								_tmp129__length1 = dv_length1;
								_tmp130_ = bsum;
								_tmp131_ = _tmp129_[_tmp130_];
								_tmp127_[_tmp128_ + 3] = _tmp131_;
								_tmp132_ = asum;
								_tmp133_ = pixels;
								_tmp134_ = p1;
								_tmp135_ = _tmp133_[_tmp134_ + 0];
								_tmp136_ = pixels;
								_tmp137_ = p2;
								_tmp138_ = _tmp136_[_tmp137_ + 0];
								asum = _tmp132_ + (_tmp135_ - _tmp138_);
								_tmp139_ = rsum;
								_tmp140_ = pixels;
								_tmp141_ = p1;
								_tmp142_ = _tmp140_[_tmp141_ + 1];
								_tmp143_ = pixels;
								_tmp144_ = p2;
								_tmp145_ = _tmp143_[_tmp144_ + 1];
								rsum = _tmp139_ + (_tmp142_ - _tmp145_);
								_tmp146_ = gsum;
								_tmp147_ = pixels;
								_tmp148_ = p1;
								_tmp149_ = _tmp147_[_tmp148_ + 2];
								_tmp150_ = pixels;
								_tmp151_ = p2;
								_tmp152_ = _tmp150_[_tmp151_ + 2];
								gsum = _tmp146_ + (_tmp149_ - _tmp152_);
								_tmp153_ = bsum;
								_tmp154_ = pixels;
								_tmp155_ = p1;
								_tmp156_ = _tmp154_[_tmp155_ + 3];
								_tmp157_ = pixels;
								_tmp158_ = p2;
								_tmp159_ = _tmp157_[_tmp158_ + 3];
								bsum = _tmp153_ + (_tmp156_ - _tmp159_);
								_tmp160_ = cur_pixel;
								_tmp161_ = channels;
								cur_pixel = _tmp160_ + _tmp161_;
							}
						}
					}
				}
			}
		}
		{
			gint y = 0;
			y = 0;
			{
				gboolean _tmp162_ = FALSE;
				_tmp162_ = TRUE;
				while (TRUE) {
					gint _tmp164_;
					gint _tmp165_;
					gint* _tmp166_;
					gint _tmp166__length1;
					gint _tmp167_;
					gint _tmp168_;
					gint _tmp169_;
					gint _tmp170_;
					gint* _tmp171_;
					gint _tmp171__length1;
					gint _tmp172_;
					gint _tmp173_;
					gint _tmp174_;
					if (!_tmp162_) {
						gint _tmp163_;
						_tmp163_ = y;
						y = _tmp163_ + 1;
					}
					_tmp162_ = FALSE;
					_tmp164_ = y;
					_tmp165_ = h;
					if (!(_tmp164_ < _tmp165_)) {
						break;
					}
					_tmp166_ = vmin;
					_tmp166__length1 = vmin_length1;
					_tmp167_ = y;
					_tmp168_ = y;
					_tmp169_ = h;
					_tmp170_ = w;
					_tmp166_[_tmp167_] = MIN ((_tmp168_ + radius) + 1, _tmp169_ - 1) * _tmp170_;
					_tmp171_ = vmax;
					_tmp171__length1 = vmax_length1;
					_tmp172_ = y;
					_tmp173_ = y;
					_tmp174_ = w;
					_tmp171_[_tmp172_] = MAX (_tmp173_ - radius, 0) * _tmp174_;
				}
			}
		}
		{
			gint x = 0;
			x = 0;
			{
				gboolean _tmp175_ = FALSE;
				_tmp175_ = TRUE;
				while (TRUE) {
					gint _tmp177_;
					gint _tmp178_;
					gint asum = 0;
					gint rsum = 0;
					gint gsum = 0;
					gint bsum = 0;
					guint32 cur_pixel = 0U;
					gint _tmp179_;
					gint _tmp180_;
					gint _tmp181_;
					guint8* _tmp182_;
					gint _tmp182__length1;
					guint32 _tmp183_;
					guint8 _tmp184_;
					gint _tmp185_;
					guint8* _tmp186_;
					gint _tmp186__length1;
					guint32 _tmp187_;
					guint8 _tmp188_;
					gint _tmp189_;
					guint8* _tmp190_;
					gint _tmp190__length1;
					guint32 _tmp191_;
					guint8 _tmp192_;
					gint _tmp193_;
					guint8* _tmp194_;
					gint _tmp194__length1;
					guint32 _tmp195_;
					guint8 _tmp196_;
					gint _tmp219_;
					gint _tmp220_;
					if (!_tmp175_) {
						gint _tmp176_;
						_tmp176_ = x;
						x = _tmp176_ + 1;
					}
					_tmp175_ = FALSE;
					_tmp177_ = x;
					_tmp178_ = w;
					if (!(_tmp177_ < _tmp178_)) {
						break;
					}
					asum = 0;
					rsum = 0;
					gsum = 0;
					bsum = 0;
					_tmp179_ = x;
					_tmp180_ = channels;
					cur_pixel = (guint32) (_tmp179_ * _tmp180_);
					_tmp181_ = asum;
					_tmp182_ = buffer;
					_tmp182__length1 = buffer_length1;
					_tmp183_ = cur_pixel;
					_tmp184_ = _tmp182_[_tmp183_ + 0];
					asum = _tmp181_ + (radius * _tmp184_);
					_tmp185_ = rsum;
					_tmp186_ = buffer;
					_tmp186__length1 = buffer_length1;
					_tmp187_ = cur_pixel;
					_tmp188_ = _tmp186_[_tmp187_ + 1];
					rsum = _tmp185_ + (radius * _tmp188_);
					_tmp189_ = gsum;
					_tmp190_ = buffer;
					_tmp190__length1 = buffer_length1;
					_tmp191_ = cur_pixel;
					_tmp192_ = _tmp190_[_tmp191_ + 2];
					gsum = _tmp189_ + (radius * _tmp192_);
					_tmp193_ = bsum;
					_tmp194_ = buffer;
					_tmp194__length1 = buffer_length1;
					_tmp195_ = cur_pixel;
					_tmp196_ = _tmp194_[_tmp195_ + 3];
					bsum = _tmp193_ + (radius * _tmp196_);
					{
						gint i = 0;
						i = 0;
						{
							gboolean _tmp197_ = FALSE;
							_tmp197_ = TRUE;
							while (TRUE) {
								gint _tmp199_;
								gint _tmp200_;
								guint8* _tmp201_;
								gint _tmp201__length1;
								guint32 _tmp202_;
								guint8 _tmp203_;
								gint _tmp204_;
								guint8* _tmp205_;
								gint _tmp205__length1;
								guint32 _tmp206_;
								guint8 _tmp207_;
								gint _tmp208_;
								guint8* _tmp209_;
								gint _tmp209__length1;
								guint32 _tmp210_;
								guint8 _tmp211_;
								gint _tmp212_;
								guint8* _tmp213_;
								gint _tmp213__length1;
								guint32 _tmp214_;
								guint8 _tmp215_;
								guint32 _tmp216_;
								gint _tmp217_;
								gint _tmp218_;
								if (!_tmp197_) {
									gint _tmp198_;
									_tmp198_ = i;
									i = _tmp198_ + 1;
								}
								_tmp197_ = FALSE;
								_tmp199_ = i;
								if (!(_tmp199_ <= radius)) {
									break;
								}
								_tmp200_ = asum;
								_tmp201_ = buffer;
								_tmp201__length1 = buffer_length1;
								_tmp202_ = cur_pixel;
								_tmp203_ = _tmp201_[_tmp202_ + 0];
								asum = _tmp200_ + _tmp203_;
								_tmp204_ = rsum;
								_tmp205_ = buffer;
								_tmp205__length1 = buffer_length1;
								_tmp206_ = cur_pixel;
								_tmp207_ = _tmp205_[_tmp206_ + 1];
								rsum = _tmp204_ + _tmp207_;
								_tmp208_ = gsum;
								_tmp209_ = buffer;
								_tmp209__length1 = buffer_length1;
								_tmp210_ = cur_pixel;
								_tmp211_ = _tmp209_[_tmp210_ + 2];
								gsum = _tmp208_ + _tmp211_;
								_tmp212_ = bsum;
								_tmp213_ = buffer;
								_tmp213__length1 = buffer_length1;
								_tmp214_ = cur_pixel;
								_tmp215_ = _tmp213_[_tmp214_ + 3];
								bsum = _tmp212_ + _tmp215_;
								_tmp216_ = cur_pixel;
								_tmp217_ = w;
								_tmp218_ = channels;
								cur_pixel = _tmp216_ + (_tmp217_ * _tmp218_);
							}
						}
					}
					_tmp219_ = x;
					_tmp220_ = channels;
					cur_pixel = (guint32) (_tmp219_ * _tmp220_);
					{
						gint y = 0;
						y = 0;
						{
							gboolean _tmp221_ = FALSE;
							_tmp221_ = TRUE;
							while (TRUE) {
								gint _tmp223_;
								gint _tmp224_;
								guint32 p1 = 0U;
								gint _tmp225_;
								gint* _tmp226_;
								gint _tmp226__length1;
								gint _tmp227_;
								gint _tmp228_;
								gint _tmp229_;
								guint32 p2 = 0U;
								gint _tmp230_;
								gint* _tmp231_;
								gint _tmp231__length1;
								gint _tmp232_;
								gint _tmp233_;
								gint _tmp234_;
								guint8* _tmp235_;
								guint32 _tmp236_;
								guint8* _tmp237_;
								gint _tmp237__length1;
								gint _tmp238_;
								guint8 _tmp239_;
								guint8* _tmp240_;
								guint32 _tmp241_;
								guint8* _tmp242_;
								gint _tmp242__length1;
								gint _tmp243_;
								guint8 _tmp244_;
								guint8* _tmp245_;
								guint32 _tmp246_;
								guint8* _tmp247_;
								gint _tmp247__length1;
								gint _tmp248_;
								guint8 _tmp249_;
								guint8* _tmp250_;
								guint32 _tmp251_;
								guint8* _tmp252_;
								gint _tmp252__length1;
								gint _tmp253_;
								guint8 _tmp254_;
								gint _tmp255_;
								guint8* _tmp256_;
								gint _tmp256__length1;
								guint32 _tmp257_;
								guint8 _tmp258_;
								guint8* _tmp259_;
								gint _tmp259__length1;
								guint32 _tmp260_;
								guint8 _tmp261_;
								gint _tmp262_;
								guint8* _tmp263_;
								gint _tmp263__length1;
								guint32 _tmp264_;
								guint8 _tmp265_;
								guint8* _tmp266_;
								gint _tmp266__length1;
								guint32 _tmp267_;
								guint8 _tmp268_;
								gint _tmp269_;
								guint8* _tmp270_;
								gint _tmp270__length1;
								guint32 _tmp271_;
								guint8 _tmp272_;
								guint8* _tmp273_;
								gint _tmp273__length1;
								guint32 _tmp274_;
								guint8 _tmp275_;
								gint _tmp276_;
								guint8* _tmp277_;
								gint _tmp277__length1;
								guint32 _tmp278_;
								guint8 _tmp279_;
								guint8* _tmp280_;
								gint _tmp280__length1;
								guint32 _tmp281_;
								guint8 _tmp282_;
								guint32 _tmp283_;
								gint _tmp284_;
								gint _tmp285_;
								if (!_tmp221_) {
									gint _tmp222_;
									_tmp222_ = y;
									y = _tmp222_ + 1;
								}
								_tmp221_ = FALSE;
								_tmp223_ = y;
								_tmp224_ = h;
								if (!(_tmp223_ < _tmp224_)) {
									break;
								}
								_tmp225_ = x;
								_tmp226_ = vmin;
								_tmp226__length1 = vmin_length1;
								_tmp227_ = y;
								_tmp228_ = _tmp226_[_tmp227_];
								_tmp229_ = channels;
								p1 = (guint32) ((_tmp225_ + _tmp228_) * _tmp229_);
								_tmp230_ = x;
								_tmp231_ = vmax;
								_tmp231__length1 = vmax_length1;
								_tmp232_ = y;
								_tmp233_ = _tmp231_[_tmp232_];
								_tmp234_ = channels;
								p2 = (guint32) ((_tmp230_ + _tmp233_) * _tmp234_);
								_tmp235_ = pixels;
								_tmp236_ = cur_pixel;
								_tmp237_ = dv;
								_tmp237__length1 = dv_length1;
								_tmp238_ = asum;
								_tmp239_ = _tmp237_[_tmp238_];
								_tmp235_[_tmp236_ + 0] = _tmp239_;
								_tmp240_ = pixels;
								_tmp241_ = cur_pixel;
								_tmp242_ = dv;
								_tmp242__length1 = dv_length1;
								_tmp243_ = rsum;
								_tmp244_ = _tmp242_[_tmp243_];
								_tmp240_[_tmp241_ + 1] = _tmp244_;
								_tmp245_ = pixels;
								_tmp246_ = cur_pixel;
								_tmp247_ = dv;
								_tmp247__length1 = dv_length1;
								_tmp248_ = gsum;
								_tmp249_ = _tmp247_[_tmp248_];
								_tmp245_[_tmp246_ + 2] = _tmp249_;
								_tmp250_ = pixels;
								_tmp251_ = cur_pixel;
								_tmp252_ = dv;
								_tmp252__length1 = dv_length1;
								_tmp253_ = bsum;
								_tmp254_ = _tmp252_[_tmp253_];
								_tmp250_[_tmp251_ + 3] = _tmp254_;
								_tmp255_ = asum;
								_tmp256_ = buffer;
								_tmp256__length1 = buffer_length1;
								_tmp257_ = p1;
								_tmp258_ = _tmp256_[_tmp257_ + 0];
								_tmp259_ = buffer;
								_tmp259__length1 = buffer_length1;
								_tmp260_ = p2;
								_tmp261_ = _tmp259_[_tmp260_ + 0];
								asum = _tmp255_ + (_tmp258_ - _tmp261_);
								_tmp262_ = rsum;
								_tmp263_ = buffer;
								_tmp263__length1 = buffer_length1;
								_tmp264_ = p1;
								_tmp265_ = _tmp263_[_tmp264_ + 1];
								_tmp266_ = buffer;
								_tmp266__length1 = buffer_length1;
								_tmp267_ = p2;
								_tmp268_ = _tmp266_[_tmp267_ + 1];
								rsum = _tmp262_ + (_tmp265_ - _tmp268_);
								_tmp269_ = gsum;
								_tmp270_ = buffer;
								_tmp270__length1 = buffer_length1;
								_tmp271_ = p1;
								_tmp272_ = _tmp270_[_tmp271_ + 2];
								_tmp273_ = buffer;
								_tmp273__length1 = buffer_length1;
								_tmp274_ = p2;
								_tmp275_ = _tmp273_[_tmp274_ + 2];
								gsum = _tmp269_ + (_tmp272_ - _tmp275_);
								_tmp276_ = bsum;
								_tmp277_ = buffer;
								_tmp277__length1 = buffer_length1;
								_tmp278_ = p1;
								_tmp279_ = _tmp277_[_tmp278_ + 3];
								_tmp280_ = buffer;
								_tmp280__length1 = buffer_length1;
								_tmp281_ = p2;
								_tmp282_ = _tmp280_[_tmp281_ + 3];
								bsum = _tmp276_ + (_tmp279_ - _tmp282_);
								_tmp283_ = cur_pixel;
								_tmp284_ = w;
								_tmp285_ = channels;
								cur_pixel = _tmp283_ + (_tmp284_ * _tmp285_);
							}
						}
					}
				}
			}
		}
	}
	_tmp286_ = original;
	cairo_surface_mark_dirty (_tmp286_);
	_tmp287_ = self->priv->_Context;
	target_cr = _tmp287_;
	_tmp288_ = target_cr;
	cairo_save (_tmp288_);
	_tmp289_ = target_cr;
	cairo_set_operator (_tmp289_, CAIRO_OPERATOR_SOURCE);
	_tmp290_ = target_cr;
	_tmp291_ = original;
	cairo_set_source_surface (_tmp290_, _tmp291_, (gdouble) 0, (gdouble) 0);
	_tmp292_ = target_cr;
	cairo_paint (_tmp292_);
	_tmp293_ = target_cr;
	cairo_restore (_tmp293_);
	dv = (g_free (dv), NULL);
	vmax = (g_free (vmax), NULL);
	vmin = (g_free (vmin), NULL);
	buffer = (g_free (buffer), NULL);
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (original);
}


/**
 * Performs an exponential blur on the surface.
 *
 * @param radius the radius of the blur
 */
static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		PlankSurface* self;
		self = _data5_->self;
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}


static void*
__lambda4_ (Block5Data* _data5_)
{
	PlankSurface* self;
	void* result = NULL;
	guint8* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	self = _data5_->self;
	_tmp0_ = _data5_->pixels;
	_tmp1_ = _data5_->width;
	_tmp2_ = _data5_->height;
	_tmp3_ = _data5_->height;
	_tmp4_ = _data5_->width;
	_tmp5_ = _data5_->alpha;
	plank_surface_exponential_blur_rows (_tmp0_, _tmp1_, _tmp2_, 0, _tmp3_ / 2, 0, _tmp4_, _tmp5_);
	result = NULL;
	return result;
}


static gpointer
___lambda4__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda4_ (self);
	block5_data_unref (self);
	return result;
}


static void*
__lambda5_ (Block5Data* _data5_)
{
	PlankSurface* self;
	void* result = NULL;
	guint8* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	self = _data5_->self;
	_tmp0_ = _data5_->pixels;
	_tmp1_ = _data5_->width;
	_tmp2_ = _data5_->height;
	_tmp3_ = _data5_->width;
	_tmp4_ = _data5_->height;
	_tmp5_ = _data5_->alpha;
	plank_surface_exponential_blur_columns (_tmp0_, _tmp1_, _tmp2_, 0, _tmp3_ / 2, 0, _tmp4_, _tmp5_);
	result = NULL;
	return result;
}


static gpointer
___lambda5__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda5_ (self);
	block5_data_unref (self);
	return result;
}


void
plank_surface_exponential_blur (PlankSurface* self,
                                gint radius)
{
	Block5Data* _data5_;
	gint _tmp0_;
	gint _tmp1_;
	cairo_surface_t* original = NULL;
	gint _tmp2_;
	gint _tmp3_;
	cairo_surface_t* _tmp4_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	cairo_surface_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_surface_t* _tmp11_;
	guchar* _tmp12_;
	GThread* th = NULL;
	GThread* _tmp13_;
	guint8* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GThread* _tmp21_;
	GThread* th2 = NULL;
	GThread* _tmp22_;
	guint8* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	GThread* _tmp30_;
	cairo_surface_t* _tmp31_;
	cairo_t* target_cr = NULL;
	cairo_t* _tmp32_;
	cairo_t* _tmp33_;
	cairo_t* _tmp34_;
	cairo_t* _tmp35_;
	cairo_surface_t* _tmp36_;
	cairo_t* _tmp37_;
	cairo_t* _tmp38_;
	g_return_if_fail (self != NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	if (radius < 1) {
		block5_data_unref (_data5_);
		_data5_ = NULL;
		return;
	}
	_data5_->alpha = (gint) ((1 << PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION) * (1.0 - exp ((-2.3) / (radius + 1.0))));
	_tmp0_ = self->priv->_Height;
	_data5_->height = _tmp0_;
	_tmp1_ = self->priv->_Width;
	_data5_->width = _tmp1_;
	_tmp2_ = _data5_->width;
	_tmp3_ = _data5_->height;
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp2_, _tmp3_);
	original = _tmp4_;
	_tmp5_ = original;
	_tmp6_ = cairo_create (_tmp5_);
	cr = _tmp6_;
	_tmp7_ = cr;
	cairo_set_operator (_tmp7_, CAIRO_OPERATOR_SOURCE);
	_tmp8_ = cr;
	_tmp9_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp8_, _tmp9_, (gdouble) 0, (gdouble) 0);
	_tmp10_ = cr;
	cairo_paint (_tmp10_);
	_tmp11_ = original;
	_tmp12_ = cairo_image_surface_get_data (_tmp11_);
	_data5_->pixels = _tmp12_;
	_tmp13_ = g_thread_new (NULL, ___lambda4__gthread_func, block5_data_ref (_data5_));
	th = _tmp13_;
	_tmp14_ = _data5_->pixels;
	_tmp15_ = _data5_->width;
	_tmp16_ = _data5_->height;
	_tmp17_ = _data5_->height;
	_tmp18_ = _data5_->height;
	_tmp19_ = _data5_->width;
	_tmp20_ = _data5_->alpha;
	plank_surface_exponential_blur_rows (_tmp14_, _tmp15_, _tmp16_, _tmp17_ / 2, _tmp18_, 0, _tmp19_, _tmp20_);
	_tmp21_ = th;
	th = NULL;
	g_thread_join (_tmp21_);
	_tmp22_ = g_thread_new (NULL, ___lambda5__gthread_func, block5_data_ref (_data5_));
	th2 = _tmp22_;
	_tmp23_ = _data5_->pixels;
	_tmp24_ = _data5_->width;
	_tmp25_ = _data5_->height;
	_tmp26_ = _data5_->width;
	_tmp27_ = _data5_->width;
	_tmp28_ = _data5_->height;
	_tmp29_ = _data5_->alpha;
	plank_surface_exponential_blur_columns (_tmp23_, _tmp24_, _tmp25_, _tmp26_ / 2, _tmp27_, 0, _tmp28_, _tmp29_);
	_tmp30_ = th2;
	th2 = NULL;
	g_thread_join (_tmp30_);
	_tmp31_ = original;
	cairo_surface_mark_dirty (_tmp31_);
	_tmp32_ = self->priv->_Context;
	target_cr = _tmp32_;
	_tmp33_ = target_cr;
	cairo_save (_tmp33_);
	_tmp34_ = target_cr;
	cairo_set_operator (_tmp34_, CAIRO_OPERATOR_SOURCE);
	_tmp35_ = target_cr;
	_tmp36_ = original;
	cairo_set_source_surface (_tmp35_, _tmp36_, (gdouble) 0, (gdouble) 0);
	_tmp37_ = target_cr;
	cairo_paint (_tmp37_);
	_tmp38_ = target_cr;
	cairo_restore (_tmp38_);
	_g_thread_unref0 (th2);
	_g_thread_unref0 (th);
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (original);
	block5_data_unref (_data5_);
	_data5_ = NULL;
}


static void
plank_surface_exponential_blur_columns (guint8* pixels,
                                        gint width,
                                        gint height,
                                        gint startCol,
                                        gint endCol,
                                        gint startY,
                                        gint endY,
                                        gint alpha)
{
	{
		gint columnIndex = 0;
		columnIndex = startCol;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				guint8* column = NULL;
				gint _tmp3_;
				gint zA = 0;
				guint8* _tmp4_;
				guint8 _tmp5_;
				gint zR = 0;
				guint8* _tmp6_;
				guint8 _tmp7_;
				gint zG = 0;
				guint8* _tmp8_;
				guint8 _tmp9_;
				gint zB = 0;
				guint8* _tmp10_;
				guint8 _tmp11_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = columnIndex;
					columnIndex = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = columnIndex;
				if (!(_tmp2_ < endCol)) {
					break;
				}
				_tmp3_ = columnIndex;
				column = pixels + (_tmp3_ * 4);
				_tmp4_ = column;
				_tmp5_ = _tmp4_[0];
				zA = _tmp5_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp6_ = column;
				_tmp7_ = _tmp6_[1];
				zR = _tmp7_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp8_ = column;
				_tmp9_ = _tmp8_[2];
				zG = _tmp9_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp10_ = column;
				_tmp11_ = _tmp10_[3];
				zB = _tmp11_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				{
					gint index = 0;
					index = width * (startY + 1);
					{
						gboolean _tmp12_ = FALSE;
						_tmp12_ = TRUE;
						while (TRUE) {
							gint _tmp14_;
							guint8* _tmp15_;
							gint _tmp16_;
							if (!_tmp12_) {
								gint _tmp13_;
								_tmp13_ = index;
								index = _tmp13_ + width;
							}
							_tmp12_ = FALSE;
							_tmp14_ = index;
							if (!(_tmp14_ < ((endY - 1) * width))) {
								break;
							}
							_tmp15_ = column;
							_tmp16_ = index;
							plank_surface_exponential_blur_inner (&_tmp15_[_tmp16_ * 4], &zA, &zR, &zG, &zB, alpha);
						}
					}
				}
				{
					gint index = 0;
					index = (endY - 2) * width;
					{
						gboolean _tmp17_ = FALSE;
						_tmp17_ = TRUE;
						while (TRUE) {
							gint _tmp19_;
							guint8* _tmp20_;
							gint _tmp21_;
							if (!_tmp17_) {
								gint _tmp18_;
								_tmp18_ = index;
								index = _tmp18_ - width;
							}
							_tmp17_ = FALSE;
							_tmp19_ = index;
							if (!(_tmp19_ >= startY)) {
								break;
							}
							_tmp20_ = column;
							_tmp21_ = index;
							plank_surface_exponential_blur_inner (&_tmp20_[_tmp21_ * 4], &zA, &zR, &zG, &zB, alpha);
						}
					}
				}
			}
		}
	}
}


static void
plank_surface_exponential_blur_rows (guint8* pixels,
                                     gint width,
                                     gint height,
                                     gint startRow,
                                     gint endRow,
                                     gint startX,
                                     gint endX,
                                     gint alpha)
{
	{
		gint rowIndex = 0;
		rowIndex = startRow;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				guint8* row = NULL;
				gint _tmp3_;
				gint zA = 0;
				guint8* _tmp4_;
				guint8 _tmp5_;
				gint zR = 0;
				guint8* _tmp6_;
				guint8 _tmp7_;
				gint zG = 0;
				guint8* _tmp8_;
				guint8 _tmp9_;
				gint zB = 0;
				guint8* _tmp10_;
				guint8 _tmp11_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = rowIndex;
					rowIndex = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = rowIndex;
				if (!(_tmp2_ < endRow)) {
					break;
				}
				_tmp3_ = rowIndex;
				row = pixels + ((_tmp3_ * width) * 4);
				_tmp4_ = row;
				_tmp5_ = _tmp4_[startX + 0];
				zA = _tmp5_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp6_ = row;
				_tmp7_ = _tmp6_[startX + 1];
				zR = _tmp7_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp8_ = row;
				_tmp9_ = _tmp8_[startX + 2];
				zG = _tmp9_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				_tmp10_ = row;
				_tmp11_ = _tmp10_[startX + 3];
				zB = _tmp11_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
				{
					gint index = 0;
					index = startX + 1;
					{
						gboolean _tmp12_ = FALSE;
						_tmp12_ = TRUE;
						while (TRUE) {
							gint _tmp14_;
							guint8* _tmp15_;
							gint _tmp16_;
							if (!_tmp12_) {
								gint _tmp13_;
								_tmp13_ = index;
								index = _tmp13_ + 1;
							}
							_tmp12_ = FALSE;
							_tmp14_ = index;
							if (!(_tmp14_ < endX)) {
								break;
							}
							_tmp15_ = row;
							_tmp16_ = index;
							plank_surface_exponential_blur_inner (&_tmp15_[_tmp16_ * 4], &zA, &zR, &zG, &zB, alpha);
						}
					}
				}
				{
					gint index = 0;
					index = endX - 2;
					{
						gboolean _tmp17_ = FALSE;
						_tmp17_ = TRUE;
						while (TRUE) {
							gint _tmp19_;
							guint8* _tmp20_;
							gint _tmp21_;
							if (!_tmp17_) {
								gint _tmp18_;
								_tmp18_ = index;
								index = _tmp18_ - 1;
							}
							_tmp17_ = FALSE;
							_tmp19_ = index;
							if (!(_tmp19_ >= startX)) {
								break;
							}
							_tmp20_ = row;
							_tmp21_ = index;
							plank_surface_exponential_blur_inner (&_tmp20_[_tmp21_ * 4], &zA, &zR, &zG, &zB, alpha);
						}
					}
				}
			}
		}
	}
}


static inline void
plank_surface_exponential_blur_inner (guint8* pixel,
                                      gint* zA,
                                      gint* zR,
                                      gint* zG,
                                      gint* zB,
                                      gint alpha)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	_tmp0_ = pixel[0];
	*zA = (*zA) + ((alpha * ((_tmp0_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - (*zA))) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
	_tmp1_ = pixel[1];
	*zR = (*zR) + ((alpha * ((_tmp1_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - (*zR))) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
	_tmp2_ = pixel[2];
	*zG = (*zG) + ((alpha * ((_tmp2_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - (*zG))) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
	_tmp3_ = pixel[3];
	*zB = (*zB) + ((alpha * ((_tmp3_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - (*zB))) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
	pixel[0] = (guint8) ((*zA) >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
	pixel[1] = (guint8) ((*zR) >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
	pixel[2] = (guint8) ((*zG) >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
	pixel[3] = (guint8) ((*zB) >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
}


/**
 * Performs a gaussian blur on the surface.
 * ''Note: This method is wickedly slow''
 *
 * @param radius the radius of the blur
 */
static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}


static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		PlankSurface* self;
		self = _data6_->self;
		_data6_->shiftar = (g_free (_data6_->shiftar), NULL);
		_data6_->bbuffer = (g_free (_data6_->bbuffer), NULL);
		_data6_->abuffer = (g_free (_data6_->abuffer), NULL);
		_data6_->kernel = (g_free (_data6_->kernel), NULL);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}


static void*
__lambda6_ (Block6Data* _data6_)
{
	PlankSurface* self;
	void* result = NULL;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	self = _data6_->self;
	_tmp0_ = _data6_->abuffer;
	_tmp0__length1 = _data6_->abuffer_length1;
	_tmp1_ = _data6_->bbuffer;
	_tmp1__length1 = _data6_->bbuffer_length1;
	_tmp2_ = _data6_->kernel;
	_tmp2__length1 = _data6_->kernel_length1;
	_tmp3_ = _data6_->gaussWidth;
	_tmp4_ = _data6_->width;
	_tmp5_ = _data6_->height;
	_tmp6_ = _data6_->height;
	_tmp7_ = _data6_->shiftar;
	_tmp7__length1 = _data6_->shiftar_length1;
	_tmp7__length2 = _data6_->shiftar_length2;
	plank_surface_gaussian_blur_horizontal (_tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_, 0, _tmp6_ / 2, _tmp7_, _tmp7__length1, _tmp7__length2);
	result = NULL;
	return result;
}


static gpointer
___lambda6__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda6_ (self);
	block6_data_unref (self);
	return result;
}


static void*
__lambda7_ (Block6Data* _data6_)
{
	PlankSurface* self;
	void* result = NULL;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	self = _data6_->self;
	_tmp0_ = _data6_->bbuffer;
	_tmp0__length1 = _data6_->bbuffer_length1;
	_tmp1_ = _data6_->abuffer;
	_tmp1__length1 = _data6_->abuffer_length1;
	_tmp2_ = _data6_->kernel;
	_tmp2__length1 = _data6_->kernel_length1;
	_tmp3_ = _data6_->gaussWidth;
	_tmp4_ = _data6_->width;
	_tmp5_ = _data6_->height;
	_tmp6_ = _data6_->width;
	_tmp7_ = _data6_->shiftar;
	_tmp7__length1 = _data6_->shiftar_length1;
	_tmp7__length2 = _data6_->shiftar_length2;
	plank_surface_gaussian_blur_vertical (_tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_, 0, _tmp6_ / 2, _tmp7_, _tmp7__length1, _tmp7__length2);
	result = NULL;
	return result;
}


static gpointer
___lambda7__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda7_ (self);
	block6_data_unref (self);
	return result;
}


void
plank_surface_gaussian_blur (PlankSurface* self,
                             gint radius)
{
	Block6Data* _data6_;
	gint _tmp0_;
	gint _tmp1_ = 0;
	gdouble* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	cairo_surface_t* original = NULL;
	gint _tmp5_;
	gint _tmp6_;
	cairo_surface_t* _tmp7_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp8_;
	cairo_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_surface_t* _tmp12_;
	cairo_t* _tmp13_;
	guint8* src = NULL;
	cairo_surface_t* _tmp14_;
	guchar* _tmp15_;
	gint size = 0;
	gint _tmp16_;
	cairo_surface_t* _tmp17_;
	gint _tmp18_;
	gdouble* _tmp19_;
	gint _tmp20_;
	gdouble* _tmp21_;
	gint _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	gint* _tmp34_;
	GThread* th = NULL;
	GThread* _tmp57_;
	gdouble* _tmp58_;
	gint _tmp58__length1;
	gdouble* _tmp59_;
	gint _tmp59__length1;
	gdouble* _tmp60_;
	gint _tmp60__length1;
	gint _tmp61_;
	gint _tmp62_;
	gint _tmp63_;
	gint _tmp64_;
	gint _tmp65_;
	gint* _tmp66_;
	gint _tmp66__length1;
	gint _tmp66__length2;
	GThread* _tmp67_;
	gdouble* _tmp68_;
	gint _tmp68__length1;
	gint _tmp69_;
	gint _tmp70_;
	gint _tmp71_;
	gint _tmp72_;
	gint* _tmp73_;
	GThread* th2 = NULL;
	GThread* _tmp97_;
	gdouble* _tmp98_;
	gint _tmp98__length1;
	gdouble* _tmp99_;
	gint _tmp99__length1;
	gdouble* _tmp100_;
	gint _tmp100__length1;
	gint _tmp101_;
	gint _tmp102_;
	gint _tmp103_;
	gint _tmp104_;
	gint _tmp105_;
	gint* _tmp106_;
	gint _tmp106__length1;
	gint _tmp106__length2;
	GThread* _tmp107_;
	cairo_surface_t* _tmp117_;
	cairo_t* target_cr = NULL;
	cairo_t* _tmp118_;
	cairo_t* _tmp119_;
	cairo_t* _tmp120_;
	cairo_t* _tmp121_;
	cairo_surface_t* _tmp122_;
	cairo_t* _tmp123_;
	cairo_t* _tmp124_;
	g_return_if_fail (self != NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	if (radius < 1) {
		block6_data_unref (_data6_);
		_data6_ = NULL;
		return;
	}
	_data6_->gaussWidth = (radius * 2) + 1;
	_tmp0_ = _data6_->gaussWidth;
	_tmp2_ = plank_surface_build_gaussian_kernel (_tmp0_, &_tmp1_);
	_data6_->kernel = _tmp2_;
	_data6_->kernel_length1 = _tmp1_;
	_data6_->_kernel_size_ = _data6_->kernel_length1;
	_tmp3_ = self->priv->_Width;
	_data6_->width = _tmp3_;
	_tmp4_ = self->priv->_Height;
	_data6_->height = _tmp4_;
	_tmp5_ = _data6_->width;
	_tmp6_ = _data6_->height;
	_tmp7_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp5_, _tmp6_);
	original = _tmp7_;
	_tmp8_ = original;
	_tmp9_ = cairo_create (_tmp8_);
	cr = _tmp9_;
	_tmp10_ = cr;
	cairo_set_operator (_tmp10_, CAIRO_OPERATOR_SOURCE);
	_tmp11_ = cr;
	_tmp12_ = self->priv->_Internal;
	cairo_set_source_surface (_tmp11_, _tmp12_, (gdouble) 0, (gdouble) 0);
	_tmp13_ = cr;
	cairo_paint (_tmp13_);
	_tmp14_ = original;
	_tmp15_ = cairo_image_surface_get_data (_tmp14_);
	src = _tmp15_;
	_tmp16_ = _data6_->height;
	_tmp17_ = original;
	size = _tmp16_ * cairo_image_surface_get_stride (_tmp17_);
	_tmp18_ = size;
	_tmp19_ = g_new0 (gdouble, _tmp18_);
	_data6_->abuffer = _tmp19_;
	_data6_->abuffer_length1 = _tmp18_;
	_data6_->_abuffer_size_ = _data6_->abuffer_length1;
	_tmp20_ = size;
	_tmp21_ = g_new0 (gdouble, _tmp20_);
	_data6_->bbuffer = _tmp21_;
	_data6_->bbuffer_length1 = _tmp20_;
	_data6_->_bbuffer_size_ = _data6_->bbuffer_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp22_ = FALSE;
			_tmp22_ = TRUE;
			while (TRUE) {
				gint _tmp24_;
				gint _tmp25_;
				gdouble* _tmp26_;
				gint _tmp26__length1;
				gint _tmp27_;
				guint8* _tmp28_;
				gint _tmp29_;
				guint8 _tmp30_;
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				_tmp24_ = i;
				_tmp25_ = size;
				if (!(_tmp24_ < _tmp25_)) {
					break;
				}
				_tmp26_ = _data6_->abuffer;
				_tmp26__length1 = _data6_->abuffer_length1;
				_tmp27_ = i;
				_tmp28_ = src;
				_tmp29_ = i;
				_tmp30_ = _tmp28_[_tmp29_];
				_tmp26_[_tmp27_] = (gdouble) _tmp30_;
			}
		}
	}
	_tmp31_ = _data6_->width;
	_tmp32_ = _data6_->height;
	_tmp33_ = _data6_->gaussWidth;
	_tmp34_ = g_new0 (gint, MAX (_tmp31_, _tmp32_) * _tmp33_);
	_data6_->shiftar = _tmp34_;
	_data6_->shiftar_length1 = MAX (_tmp31_, _tmp32_);
	_data6_->shiftar_length2 = _tmp33_;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp35_ = FALSE;
			_tmp35_ = TRUE;
			while (TRUE) {
				gint _tmp37_;
				gint _tmp38_;
				if (!_tmp35_) {
					gint _tmp36_;
					_tmp36_ = x;
					x = _tmp36_ + 1;
				}
				_tmp35_ = FALSE;
				_tmp37_ = x;
				_tmp38_ = _data6_->width;
				if (!(_tmp37_ < _tmp38_)) {
					break;
				}
				{
					gint k = 0;
					k = 0;
					{
						gboolean _tmp39_ = FALSE;
						_tmp39_ = TRUE;
						while (TRUE) {
							gint _tmp41_;
							gint _tmp42_;
							gint shift = 0;
							gint _tmp43_;
							gboolean _tmp44_ = FALSE;
							gint _tmp45_;
							gint _tmp46_;
							if (!_tmp39_) {
								gint _tmp40_;
								_tmp40_ = k;
								k = _tmp40_ + 1;
							}
							_tmp39_ = FALSE;
							_tmp41_ = k;
							_tmp42_ = _data6_->gaussWidth;
							if (!(_tmp41_ < _tmp42_)) {
								break;
							}
							_tmp43_ = k;
							shift = _tmp43_ - radius;
							_tmp45_ = x;
							_tmp46_ = shift;
							if ((_tmp45_ + _tmp46_) <= 0) {
								_tmp44_ = TRUE;
							} else {
								gint _tmp47_;
								gint _tmp48_;
								gint _tmp49_;
								_tmp47_ = x;
								_tmp48_ = shift;
								_tmp49_ = _data6_->width;
								_tmp44_ = (_tmp47_ + _tmp48_) >= _tmp49_;
							}
							if (_tmp44_) {
								gint* _tmp50_;
								gint _tmp50__length1;
								gint _tmp50__length2;
								gint _tmp51_;
								gint _tmp52_;
								_tmp50_ = _data6_->shiftar;
								_tmp50__length1 = _data6_->shiftar_length1;
								_tmp50__length2 = _data6_->shiftar_length2;
								_tmp51_ = x;
								_tmp52_ = k;
								_tmp50_[(_tmp51_ * _tmp50__length2) + _tmp52_] = 0;
							} else {
								gint* _tmp53_;
								gint _tmp53__length1;
								gint _tmp53__length2;
								gint _tmp54_;
								gint _tmp55_;
								gint _tmp56_;
								_tmp53_ = _data6_->shiftar;
								_tmp53__length1 = _data6_->shiftar_length1;
								_tmp53__length2 = _data6_->shiftar_length2;
								_tmp54_ = x;
								_tmp55_ = k;
								_tmp56_ = shift;
								_tmp53_[(_tmp54_ * _tmp53__length2) + _tmp55_] = _tmp56_ * 4;
							}
						}
					}
				}
			}
		}
	}
	_tmp57_ = g_thread_new (NULL, ___lambda6__gthread_func, block6_data_ref (_data6_));
	th = _tmp57_;
	_tmp58_ = _data6_->abuffer;
	_tmp58__length1 = _data6_->abuffer_length1;
	_tmp59_ = _data6_->bbuffer;
	_tmp59__length1 = _data6_->bbuffer_length1;
	_tmp60_ = _data6_->kernel;
	_tmp60__length1 = _data6_->kernel_length1;
	_tmp61_ = _data6_->gaussWidth;
	_tmp62_ = _data6_->width;
	_tmp63_ = _data6_->height;
	_tmp64_ = _data6_->height;
	_tmp65_ = _data6_->height;
	_tmp66_ = _data6_->shiftar;
	_tmp66__length1 = _data6_->shiftar_length1;
	_tmp66__length2 = _data6_->shiftar_length2;
	plank_surface_gaussian_blur_horizontal (_tmp58_, _tmp59_, _tmp60_, _tmp61_, _tmp62_, _tmp63_, _tmp64_ / 2, _tmp65_, _tmp66_, _tmp66__length1, _tmp66__length2);
	_tmp67_ = th;
	th = NULL;
	g_thread_join (_tmp67_);
	_tmp68_ = _data6_->abuffer;
	_tmp68__length1 = _data6_->abuffer_length1;
	_tmp69_ = size;
	memset (_tmp68_, 0, (gsize) (sizeof (gdouble) * _tmp69_));
	_tmp70_ = _data6_->width;
	_tmp71_ = _data6_->height;
	_tmp72_ = _data6_->gaussWidth;
	_tmp73_ = g_new0 (gint, MAX (_tmp70_, _tmp71_) * _tmp72_);
	_data6_->shiftar = (g_free (_data6_->shiftar), NULL);
	_data6_->shiftar = _tmp73_;
	_data6_->shiftar_length1 = MAX (_tmp70_, _tmp71_);
	_data6_->shiftar_length2 = _tmp72_;
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp74_ = FALSE;
			_tmp74_ = TRUE;
			while (TRUE) {
				gint _tmp76_;
				gint _tmp77_;
				if (!_tmp74_) {
					gint _tmp75_;
					_tmp75_ = y;
					y = _tmp75_ + 1;
				}
				_tmp74_ = FALSE;
				_tmp76_ = y;
				_tmp77_ = _data6_->height;
				if (!(_tmp76_ < _tmp77_)) {
					break;
				}
				{
					gint k = 0;
					k = 0;
					{
						gboolean _tmp78_ = FALSE;
						_tmp78_ = TRUE;
						while (TRUE) {
							gint _tmp80_;
							gint _tmp81_;
							gint shift = 0;
							gint _tmp82_;
							gboolean _tmp83_ = FALSE;
							gint _tmp84_;
							gint _tmp85_;
							if (!_tmp78_) {
								gint _tmp79_;
								_tmp79_ = k;
								k = _tmp79_ + 1;
							}
							_tmp78_ = FALSE;
							_tmp80_ = k;
							_tmp81_ = _data6_->gaussWidth;
							if (!(_tmp80_ < _tmp81_)) {
								break;
							}
							_tmp82_ = k;
							shift = _tmp82_ - radius;
							_tmp84_ = y;
							_tmp85_ = shift;
							if ((_tmp84_ + _tmp85_) <= 0) {
								_tmp83_ = TRUE;
							} else {
								gint _tmp86_;
								gint _tmp87_;
								gint _tmp88_;
								_tmp86_ = y;
								_tmp87_ = shift;
								_tmp88_ = _data6_->height;
								_tmp83_ = (_tmp86_ + _tmp87_) >= _tmp88_;
							}
							if (_tmp83_) {
								gint* _tmp89_;
								gint _tmp89__length1;
								gint _tmp89__length2;
								gint _tmp90_;
								gint _tmp91_;
								_tmp89_ = _data6_->shiftar;
								_tmp89__length1 = _data6_->shiftar_length1;
								_tmp89__length2 = _data6_->shiftar_length2;
								_tmp90_ = y;
								_tmp91_ = k;
								_tmp89_[(_tmp90_ * _tmp89__length2) + _tmp91_] = 0;
							} else {
								gint* _tmp92_;
								gint _tmp92__length1;
								gint _tmp92__length2;
								gint _tmp93_;
								gint _tmp94_;
								gint _tmp95_;
								gint _tmp96_;
								_tmp92_ = _data6_->shiftar;
								_tmp92__length1 = _data6_->shiftar_length1;
								_tmp92__length2 = _data6_->shiftar_length2;
								_tmp93_ = y;
								_tmp94_ = k;
								_tmp95_ = shift;
								_tmp96_ = _data6_->width;
								_tmp92_[(_tmp93_ * _tmp92__length2) + _tmp94_] = (_tmp95_ * _tmp96_) * 4;
							}
						}
					}
				}
			}
		}
	}
	_tmp97_ = g_thread_new (NULL, ___lambda7__gthread_func, block6_data_ref (_data6_));
	th2 = _tmp97_;
	_tmp98_ = _data6_->bbuffer;
	_tmp98__length1 = _data6_->bbuffer_length1;
	_tmp99_ = _data6_->abuffer;
	_tmp99__length1 = _data6_->abuffer_length1;
	_tmp100_ = _data6_->kernel;
	_tmp100__length1 = _data6_->kernel_length1;
	_tmp101_ = _data6_->gaussWidth;
	_tmp102_ = _data6_->width;
	_tmp103_ = _data6_->height;
	_tmp104_ = _data6_->width;
	_tmp105_ = _data6_->width;
	_tmp106_ = _data6_->shiftar;
	_tmp106__length1 = _data6_->shiftar_length1;
	_tmp106__length2 = _data6_->shiftar_length2;
	plank_surface_gaussian_blur_vertical (_tmp98_, _tmp99_, _tmp100_, _tmp101_, _tmp102_, _tmp103_, _tmp104_ / 2, _tmp105_, _tmp106_, _tmp106__length1, _tmp106__length2);
	_tmp107_ = th2;
	th2 = NULL;
	g_thread_join (_tmp107_);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp108_ = FALSE;
			_tmp108_ = TRUE;
			while (TRUE) {
				gint _tmp110_;
				gint _tmp111_;
				guint8* _tmp112_;
				gint _tmp113_;
				gdouble* _tmp114_;
				gint _tmp114__length1;
				gint _tmp115_;
				gdouble _tmp116_;
				if (!_tmp108_) {
					gint _tmp109_;
					_tmp109_ = i;
					i = _tmp109_ + 1;
				}
				_tmp108_ = FALSE;
				_tmp110_ = i;
				_tmp111_ = size;
				if (!(_tmp110_ < _tmp111_)) {
					break;
				}
				_tmp112_ = src;
				_tmp113_ = i;
				_tmp114_ = _data6_->abuffer;
				_tmp114__length1 = _data6_->abuffer_length1;
				_tmp115_ = i;
				_tmp116_ = _tmp114_[_tmp115_];
				_tmp112_[_tmp113_] = (guint8) _tmp116_;
			}
		}
	}
	_tmp117_ = original;
	cairo_surface_mark_dirty (_tmp117_);
	_tmp118_ = self->priv->_Context;
	target_cr = _tmp118_;
	_tmp119_ = target_cr;
	cairo_save (_tmp119_);
	_tmp120_ = target_cr;
	cairo_set_operator (_tmp120_, CAIRO_OPERATOR_SOURCE);
	_tmp121_ = target_cr;
	_tmp122_ = original;
	cairo_set_source_surface (_tmp121_, _tmp122_, (gdouble) 0, (gdouble) 0);
	_tmp123_ = target_cr;
	cairo_paint (_tmp123_);
	_tmp124_ = target_cr;
	cairo_restore (_tmp124_);
	_g_thread_unref0 (th2);
	_g_thread_unref0 (th);
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (original);
	block6_data_unref (_data6_);
	_data6_ = NULL;
}


static void
plank_surface_gaussian_blur_horizontal (gdouble* src,
                                        gdouble* dest,
                                        gdouble* kernel,
                                        gint gaussWidth,
                                        gint width,
                                        gint height,
                                        gint startRow,
                                        gint endRow,
                                        gint* shift,
                                        int shift_length1,
                                        int shift_length2)
{
	guint32 cur_pixel = 0U;
	cur_pixel = (guint32) ((startRow * width) * 4);
	{
		gint y = 0;
		y = startRow;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = y;
					y = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = y;
				if (!(_tmp2_ < endRow)) {
					break;
				}
				{
					gint x = 0;
					x = 0;
					{
						gboolean _tmp3_ = FALSE;
						_tmp3_ = TRUE;
						while (TRUE) {
							gint _tmp5_;
							guint32 _tmp31_;
							if (!_tmp3_) {
								gint _tmp4_;
								_tmp4_ = x;
								x = _tmp4_ + 1;
							}
							_tmp3_ = FALSE;
							_tmp5_ = x;
							if (!(_tmp5_ < width)) {
								break;
							}
							{
								gint k = 0;
								k = 0;
								{
									gboolean _tmp6_ = FALSE;
									_tmp6_ = TRUE;
									while (TRUE) {
										gint _tmp8_;
										guint32 source = 0U;
										guint32 _tmp9_;
										gint _tmp10_;
										gint _tmp11_;
										gint _tmp12_;
										gdouble kernel_k = 0.0;
										gint _tmp13_;
										gdouble _tmp14_;
										guint32 _tmp15_;
										guint32 _tmp16_;
										gdouble _tmp17_;
										gdouble _tmp18_;
										guint32 _tmp19_;
										guint32 _tmp20_;
										gdouble _tmp21_;
										gdouble _tmp22_;
										guint32 _tmp23_;
										guint32 _tmp24_;
										gdouble _tmp25_;
										gdouble _tmp26_;
										guint32 _tmp27_;
										guint32 _tmp28_;
										gdouble _tmp29_;
										gdouble _tmp30_;
										if (!_tmp6_) {
											gint _tmp7_;
											_tmp7_ = k;
											k = _tmp7_ + 1;
										}
										_tmp6_ = FALSE;
										_tmp8_ = k;
										if (!(_tmp8_ < gaussWidth)) {
											break;
										}
										_tmp9_ = cur_pixel;
										_tmp10_ = x;
										_tmp11_ = k;
										_tmp12_ = shift[(_tmp10_ * shift_length2) + _tmp11_];
										source = _tmp9_ + _tmp12_;
										_tmp13_ = k;
										_tmp14_ = kernel[_tmp13_];
										kernel_k = _tmp14_;
										_tmp15_ = cur_pixel;
										_tmp16_ = source;
										_tmp17_ = src[_tmp16_ + 0];
										_tmp18_ = kernel_k;
										dest[_tmp15_ + 0] += _tmp17_ * _tmp18_;
										_tmp19_ = cur_pixel;
										_tmp20_ = source;
										_tmp21_ = src[_tmp20_ + 1];
										_tmp22_ = kernel_k;
										dest[_tmp19_ + 1] += _tmp21_ * _tmp22_;
										_tmp23_ = cur_pixel;
										_tmp24_ = source;
										_tmp25_ = src[_tmp24_ + 2];
										_tmp26_ = kernel_k;
										dest[_tmp23_ + 2] += _tmp25_ * _tmp26_;
										_tmp27_ = cur_pixel;
										_tmp28_ = source;
										_tmp29_ = src[_tmp28_ + 3];
										_tmp30_ = kernel_k;
										dest[_tmp27_ + 3] += _tmp29_ * _tmp30_;
									}
								}
							}
							_tmp31_ = cur_pixel;
							cur_pixel = _tmp31_ + 4;
						}
					}
				}
			}
		}
	}
}


static void
plank_surface_gaussian_blur_vertical (gdouble* src,
                                      gdouble* dest,
                                      gdouble* kernel,
                                      gint gaussWidth,
                                      gint width,
                                      gint height,
                                      gint startCol,
                                      gint endCol,
                                      gint* shift,
                                      int shift_length1,
                                      int shift_length2)
{
	guint32 cur_pixel = 0U;
	cur_pixel = (guint32) (startCol * 4);
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				guint32 _tmp32_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = y;
					y = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = y;
				if (!(_tmp2_ < height)) {
					break;
				}
				{
					gint x = 0;
					x = startCol;
					{
						gboolean _tmp3_ = FALSE;
						_tmp3_ = TRUE;
						while (TRUE) {
							gint _tmp5_;
							guint32 _tmp31_;
							if (!_tmp3_) {
								gint _tmp4_;
								_tmp4_ = x;
								x = _tmp4_ + 1;
							}
							_tmp3_ = FALSE;
							_tmp5_ = x;
							if (!(_tmp5_ < endCol)) {
								break;
							}
							{
								gint k = 0;
								k = 0;
								{
									gboolean _tmp6_ = FALSE;
									_tmp6_ = TRUE;
									while (TRUE) {
										gint _tmp8_;
										guint32 source = 0U;
										guint32 _tmp9_;
										gint _tmp10_;
										gint _tmp11_;
										gint _tmp12_;
										gdouble kernel_k = 0.0;
										gint _tmp13_;
										gdouble _tmp14_;
										guint32 _tmp15_;
										guint32 _tmp16_;
										gdouble _tmp17_;
										gdouble _tmp18_;
										guint32 _tmp19_;
										guint32 _tmp20_;
										gdouble _tmp21_;
										gdouble _tmp22_;
										guint32 _tmp23_;
										guint32 _tmp24_;
										gdouble _tmp25_;
										gdouble _tmp26_;
										guint32 _tmp27_;
										guint32 _tmp28_;
										gdouble _tmp29_;
										gdouble _tmp30_;
										if (!_tmp6_) {
											gint _tmp7_;
											_tmp7_ = k;
											k = _tmp7_ + 1;
										}
										_tmp6_ = FALSE;
										_tmp8_ = k;
										if (!(_tmp8_ < gaussWidth)) {
											break;
										}
										_tmp9_ = cur_pixel;
										_tmp10_ = y;
										_tmp11_ = k;
										_tmp12_ = shift[(_tmp10_ * shift_length2) + _tmp11_];
										source = _tmp9_ + _tmp12_;
										_tmp13_ = k;
										_tmp14_ = kernel[_tmp13_];
										kernel_k = _tmp14_;
										_tmp15_ = cur_pixel;
										_tmp16_ = source;
										_tmp17_ = src[_tmp16_ + 0];
										_tmp18_ = kernel_k;
										dest[_tmp15_ + 0] += _tmp17_ * _tmp18_;
										_tmp19_ = cur_pixel;
										_tmp20_ = source;
										_tmp21_ = src[_tmp20_ + 1];
										_tmp22_ = kernel_k;
										dest[_tmp19_ + 1] += _tmp21_ * _tmp22_;
										_tmp23_ = cur_pixel;
										_tmp24_ = source;
										_tmp25_ = src[_tmp24_ + 2];
										_tmp26_ = kernel_k;
										dest[_tmp23_ + 2] += _tmp25_ * _tmp26_;
										_tmp27_ = cur_pixel;
										_tmp28_ = source;
										_tmp29_ = src[_tmp28_ + 3];
										_tmp30_ = kernel_k;
										dest[_tmp27_ + 3] += _tmp29_ * _tmp30_;
									}
								}
							}
							_tmp31_ = cur_pixel;
							cur_pixel = _tmp31_ + 4;
						}
					}
				}
				_tmp32_ = cur_pixel;
				cur_pixel = _tmp32_ + (((width - endCol) + startCol) * 4);
			}
		}
	}
}


static gdouble*
plank_surface_build_gaussian_kernel (gint gaussWidth,
                                     int* result_length1)
{
	gdouble* result = NULL;
	gdouble* kernel = NULL;
	gdouble* _tmp0_;
	gint kernel_length1;
	gint _kernel_size_;
	gdouble sd = 0.0;
	gint range = 0;
	gdouble mean = 0.0;
	gint _tmp1_;
	gdouble _tmp2_;
	gdouble gaussSum = 0.0;
	gdouble* _tmp14_;
	gint _tmp14__length1;
	gdouble* _tmp27_;
	gint _tmp27__length1;
	_vala_return_val_if_fail ((gaussWidth % 2) == 1, "gaussWidth % 2 == 1", NULL);
	_tmp0_ = g_new0 (gdouble, gaussWidth);
	kernel = _tmp0_;
	kernel_length1 = gaussWidth;
	_kernel_size_ = kernel_length1;
	sd = 255.0;
	range = gaussWidth;
	_tmp1_ = range;
	_tmp2_ = sd;
	mean = _tmp1_ / _tmp2_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_;
				gdouble* _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				gdouble* _tmp8_;
				gint _tmp8__length1;
				gint _tmp9_;
				gint _tmp10_;
				gdouble _tmp11_;
				gint _tmp12_;
				gdouble _tmp13_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = i;
				if (!(_tmp5_ < ((gaussWidth / 2) + 1))) {
					break;
				}
				_tmp6_ = kernel;
				_tmp6__length1 = kernel_length1;
				_tmp7_ = i;
				_tmp8_ = kernel;
				_tmp8__length1 = kernel_length1;
				_tmp9_ = i;
				_tmp10_ = i;
				_tmp11_ = mean;
				_tmp12_ = range;
				_tmp13_ = sd;
				_tmp8_[_tmp9_] = pow (sin ((((_tmp10_ + 1) * G_PI_2) - _tmp11_) / _tmp12_), (gdouble) 2) * _tmp13_;
				_tmp6_[(gaussWidth - _tmp7_) - 1] = pow (sin ((((_tmp10_ + 1) * G_PI_2) - _tmp11_) / _tmp12_), (gdouble) 2) * _tmp13_;
			}
		}
	}
	gaussSum = 0.0;
	_tmp14_ = kernel;
	_tmp14__length1 = kernel_length1;
	{
		gdouble* d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
		d_collection = _tmp14_;
		d_collection_length1 = _tmp14__length1;
		for (d_it = 0; d_it < _tmp14__length1; d_it = d_it + 1) {
			gdouble d = 0.0;
			d = d_collection[d_it];
			{
				gdouble _tmp15_;
				gdouble _tmp16_;
				_tmp15_ = gaussSum;
				_tmp16_ = d;
				gaussSum = _tmp15_ + _tmp16_;
			}
		}
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp17_ = FALSE;
			_tmp17_ = TRUE;
			while (TRUE) {
				gint _tmp19_;
				gdouble* _tmp20_;
				gint _tmp20__length1;
				gdouble* _tmp21_;
				gint _tmp21__length1;
				gint _tmp22_;
				gdouble* _tmp23_;
				gint _tmp23__length1;
				gint _tmp24_;
				gdouble _tmp25_;
				gdouble _tmp26_;
				if (!_tmp17_) {
					gint _tmp18_;
					_tmp18_ = i;
					i = _tmp18_ + 1;
				}
				_tmp17_ = FALSE;
				_tmp19_ = i;
				_tmp20_ = kernel;
				_tmp20__length1 = kernel_length1;
				if (!(_tmp19_ < _tmp20__length1)) {
					break;
				}
				_tmp21_ = kernel;
				_tmp21__length1 = kernel_length1;
				_tmp22_ = i;
				_tmp23_ = kernel;
				_tmp23__length1 = kernel_length1;
				_tmp24_ = i;
				_tmp25_ = _tmp23_[_tmp24_];
				_tmp26_ = gaussSum;
				_tmp21_[_tmp22_] = _tmp25_ / _tmp26_;
			}
		}
	}
	_tmp27_ = kernel;
	_tmp27__length1 = kernel_length1;
	if (result_length1) {
		*result_length1 = _tmp27__length1;
	}
	result = _tmp27_;
	return result;
}


cairo_surface_t*
plank_surface_get_Internal (PlankSurface* self)
{
	cairo_surface_t* result;
	cairo_surface_t* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Internal;
	result = _tmp0_;
	return result;
}


static gpointer
_cairo_surface_reference0 (gpointer self)
{
	return self ? cairo_surface_reference (self) : NULL;
}


static void
plank_surface_set_Internal (PlankSurface* self,
                            cairo_surface_t* value)
{
	g_return_if_fail (self != NULL);
	if (plank_surface_get_Internal (self) != value) {
		cairo_surface_t* _tmp0_;
		_tmp0_ = _cairo_surface_reference0 (value);
		_cairo_surface_destroy0 (self->priv->_Internal);
		self->priv->_Internal = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, plank_surface_properties[PLANK_SURFACE_INTERNAL_PROPERTY]);
	}
}


gint
plank_surface_get_Width (PlankSurface* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_Width;
	result = _tmp0_;
	return result;
}


static void
plank_surface_set_Width (PlankSurface* self,
                         gint value)
{
	g_return_if_fail (self != NULL);
	if (plank_surface_get_Width (self) != value) {
		self->priv->_Width = value;
		g_object_notify_by_pspec ((GObject *) self, plank_surface_properties[PLANK_SURFACE_WIDTH_PROPERTY]);
	}
}


gint
plank_surface_get_Height (PlankSurface* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_Height;
	result = _tmp0_;
	return result;
}


static void
plank_surface_set_Height (PlankSurface* self,
                          gint value)
{
	g_return_if_fail (self != NULL);
	if (plank_surface_get_Height (self) != value) {
		self->priv->_Height = value;
		g_object_notify_by_pspec ((GObject *) self, plank_surface_properties[PLANK_SURFACE_HEIGHT_PROPERTY]);
	}
}


cairo_t*
plank_surface_get_Context (PlankSurface* self)
{
	cairo_t* result;
	cairo_t* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Context;
	result = _tmp0_;
	return result;
}


static gpointer
_cairo_reference0 (gpointer self)
{
	return self ? cairo_reference (self) : NULL;
}


static void
plank_surface_set_Context (PlankSurface* self,
                           cairo_t* value)
{
	g_return_if_fail (self != NULL);
	if (plank_surface_get_Context (self) != value) {
		cairo_t* _tmp0_;
		_tmp0_ = _cairo_reference0 (value);
		_cairo_destroy0 (self->priv->_Context);
		self->priv->_Context = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, plank_surface_properties[PLANK_SURFACE_CONTEXT_PROPERTY]);
	}
}


static GObject *
plank_surface_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankSurface * self;
	cairo_surface_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	parent_class = G_OBJECT_CLASS (plank_surface_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_SURFACE, PlankSurface);
	_tmp0_ = self->priv->_Internal;
	_tmp1_ = cairo_create (_tmp0_);
	_tmp2_ = _tmp1_;
	plank_surface_set_Context (self, _tmp2_);
	_cairo_destroy0 (_tmp2_);
	return obj;
}


static void
plank_surface_class_init (PlankSurfaceClass * klass)
{
	plank_surface_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PlankSurface_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_surface_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_surface_set_property;
	G_OBJECT_CLASS (klass)->constructor = plank_surface_constructor;
	G_OBJECT_CLASS (klass)->finalize = plank_surface_finalize;
	/**
	 * The internal {@link Cairo.Surface} backing the surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_INTERNAL_PROPERTY, plank_surface_properties[PLANK_SURFACE_INTERNAL_PROPERTY] = g_param_spec_pointer ("Internal", "Internal", "Internal", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * The width of the surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_WIDTH_PROPERTY, plank_surface_properties[PLANK_SURFACE_WIDTH_PROPERTY] = g_param_spec_int ("Width", "Width", "Width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * The height of the surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_HEIGHT_PROPERTY, plank_surface_properties[PLANK_SURFACE_HEIGHT_PROPERTY] = g_param_spec_int ("Height", "Height", "Height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * A {@link Cairo.Context} for the surface.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_CONTEXT_PROPERTY, plank_surface_properties[PLANK_SURFACE_CONTEXT_PROPERTY] = g_param_spec_pointer ("Context", "Context", "Context", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void
plank_surface_instance_init (PlankSurface * self)
{
	self->priv = plank_surface_get_instance_private (self);
}


static void
plank_surface_finalize (GObject * obj)
{
	PlankSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_SURFACE, PlankSurface);
	_cairo_surface_destroy0 (self->priv->_Internal);
	_cairo_destroy0 (self->priv->_Context);
	G_OBJECT_CLASS (plank_surface_parent_class)->finalize (obj);
}


/**
 * A surface is a wrapper class for a {@link Cairo.Surface}.
 * It encapsulates a surface/context and provides utility methods.
 */
GType
plank_surface_get_type (void)
{
	static volatile gsize plank_surface_type_id__volatile = 0;
	if (g_once_init_enter (&plank_surface_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankSurfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_surface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankSurface), 0, (GInstanceInitFunc) plank_surface_instance_init, NULL };
		GType plank_surface_type_id;
		plank_surface_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankSurface", &g_define_type_info, 0);
		PlankSurface_private_offset = g_type_add_instance_private (plank_surface_type_id, sizeof (PlankSurfacePrivate));
		g_once_init_leave (&plank_surface_type_id__volatile, plank_surface_type_id);
	}
	return plank_surface_type_id__volatile;
}


static void
_vala_plank_surface_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	PlankSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_SURFACE, PlankSurface);
	switch (property_id) {
		case PLANK_SURFACE_INTERNAL_PROPERTY:
		g_value_set_pointer (value, plank_surface_get_Internal (self));
		break;
		case PLANK_SURFACE_WIDTH_PROPERTY:
		g_value_set_int (value, plank_surface_get_Width (self));
		break;
		case PLANK_SURFACE_HEIGHT_PROPERTY:
		g_value_set_int (value, plank_surface_get_Height (self));
		break;
		case PLANK_SURFACE_CONTEXT_PROPERTY:
		g_value_set_pointer (value, plank_surface_get_Context (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_plank_surface_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	PlankSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_SURFACE, PlankSurface);
	switch (property_id) {
		case PLANK_SURFACE_INTERNAL_PROPERTY:
		plank_surface_set_Internal (self, g_value_get_pointer (value));
		break;
		case PLANK_SURFACE_WIDTH_PROPERTY:
		plank_surface_set_Width (self, g_value_get_int (value));
		break;
		case PLANK_SURFACE_HEIGHT_PROPERTY:
		plank_surface_set_Height (self, g_value_get_int (value));
		break;
		case PLANK_SURFACE_CONTEXT_PROPERTY:
		plank_surface_set_Context (self, g_value_get_pointer (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



