/* Preferences.c generated by valac 0.42.7, the Vala compiler
 * generated from Preferences.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>


#define PLANK_TYPE_SERIALIZABLE (plank_serializable_get_type ())
#define PLANK_SERIALIZABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_SERIALIZABLE, PlankSerializable))
#define PLANK_IS_SERIALIZABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_SERIALIZABLE))
#define PLANK_SERIALIZABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLANK_TYPE_SERIALIZABLE, PlankSerializableIface))

typedef struct _PlankSerializable PlankSerializable;
typedef struct _PlankSerializableIface PlankSerializableIface;

#define PLANK_TYPE_PREFERENCES (plank_preferences_get_type ())
#define PLANK_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_PREFERENCES, PlankPreferences))
#define PLANK_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_PREFERENCES, PlankPreferencesClass))
#define PLANK_IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_PREFERENCES))
#define PLANK_IS_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_PREFERENCES))
#define PLANK_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_PREFERENCES, PlankPreferencesClass))

typedef struct _PlankPreferences PlankPreferences;
typedef struct _PlankPreferencesClass PlankPreferencesClass;
typedef struct _PlankPreferencesPrivate PlankPreferencesPrivate;
enum  {
	PLANK_PREFERENCES_0_PROPERTY,
	PLANK_PREFERENCES_NUM_PROPERTIES
};
static GParamSpec* plank_preferences_properties[PLANK_PREFERENCES_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))

#define PLANK_TYPE_COLOR (plank_color_get_type ())
typedef GdkRGBA PlankColor;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
enum  {
	PLANK_PREFERENCES_DELETED_SIGNAL,
	PLANK_PREFERENCES_NUM_SIGNALS
};
static guint plank_preferences_signals[PLANK_PREFERENCES_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PlankSerializableIface {
	GTypeInterface parent_iface;
	gchar* (*serialize) (PlankSerializable* self);
	void (*deserialize) (PlankSerializable* self, const gchar* s);
};

struct _PlankPreferences {
	GObject parent_instance;
	PlankPreferencesPrivate * priv;
};

struct _PlankPreferencesClass {
	GObjectClass parent_class;
	void (*verify) (PlankPreferences* self, const gchar* prop);
	void (*reset_properties) (PlankPreferences* self);
};

struct _PlankPreferencesPrivate {
	GFile* backing_file;
	GFileMonitor* backing_monitor;
	gboolean read_only;
	gboolean is_delayed;
	gboolean is_delayed_internal;
	gboolean is_changed;
};


static gint PlankPreferences_private_offset;
static gpointer plank_preferences_parent_class = NULL;
static gchar** plank_preferences_TRANSITION_MAP;
static gint plank_preferences_TRANSITION_MAP_length1;
static gint plank_preferences_TRANSITION_MAP_length2;
static gchar** plank_preferences_TRANSITION_MAP = NULL;
static gint plank_preferences_TRANSITION_MAP_length1 = 0;
static gint plank_preferences_TRANSITION_MAP_length2 = 0;

GType plank_serializable_get_type (void) G_GNUC_CONST;
gchar* plank_serializable_serialize (PlankSerializable* self);
void plank_serializable_deserialize (PlankSerializable* self,
                                     const gchar* s);
GType plank_preferences_get_type (void) G_GNUC_CONST;
static void plank_preferences_handle_notify (PlankPreferences* self,
                                      GObject* sender,
                                      GParamSpec* property);
static void _plank_preferences_handle_notify_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
void plank_preferences_apply (PlankPreferences* self);
static void plank_preferences_stop_monitor (PlankPreferences* self);
PlankPreferences* plank_preferences_construct (GType object_type);
void plank_logger_verbose (const gchar* msg,
                           ...);
static void plank_preferences_save_prefs (PlankPreferences* self);
static void plank_preferences_call_verify (PlankPreferences* self,
                                    const gchar* prop);
static void plank_preferences_handle_verify_notify (PlankPreferences* self,
                                             GObject* sender,
                                             GParamSpec* property);
static void _plank_preferences_handle_verify_notify_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
void plank_preferences_verify (PlankPreferences* self,
                               const gchar* prop);
static void plank_preferences_real_verify (PlankPreferences* self,
                                    const gchar* prop);
void plank_preferences_reset_properties (PlankPreferences* self);
static void plank_preferences_real_reset_properties (PlankPreferences* self);
PlankPreferences* plank_preferences_construct_with_file (GType object_type,
                                                         GFile* file);
void plank_preferences_init_from_file (PlankPreferences* self,
                                       GFile* file);
PlankPreferences* plank_preferences_construct_with_filename (GType object_type,
                                                             const gchar* filename);
GFile* plank_paths_get_AppConfigFolder (void);
static void plank_preferences_load_prefs (PlankPreferences* self);
static void plank_preferences_start_monitor (PlankPreferences* self);
void plank_preferences_init_from_filename (PlankPreferences* self,
                                           const gchar* filename);
void plank_preferences_delay (PlankPreferences* self);
gchar* plank_preferences_get_filename (PlankPreferences* self);
GFile* plank_preferences_get_backing_file (PlankPreferences* self);
void plank_preferences_delete (PlankPreferences* self);
static void plank_preferences_backing_file_changed (GFile* f,
                                             GFile* other,
                                             GFileMonitorEvent event,
                                             PlankPreferences* self);
static void _plank_preferences_backing_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                                     GFile* file,
                                                                     GFile* other_file,
                                                                     GFileMonitorEvent event_type,
                                                                     gpointer self);
GType plank_color_get_type (void) G_GNUC_CONST;
PlankColor* plank_color_dup (const PlankColor* self);
void plank_color_free (PlankColor* self);
gchar* plank_color_to_prefs_string (PlankColor *self);
void plank_color_from_prefs_string (const gchar* s,
                                    PlankColor* result);
static GObject * plank_preferences_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void plank_preferences_finalize (GObject * obj);


/**
 * Serializes the object into a string representation.
 *
 * @return the string representation of the object
 */
gchar*
plank_serializable_serialize (PlankSerializable* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return PLANK_SERIALIZABLE_GET_INTERFACE (self)->serialize (self);
}


/**
 * De-serializes the object from a string representation.
 *
 * @param s the string representation of the object
 */
void
plank_serializable_deserialize (PlankSerializable* self,
                                const gchar* s)
{
	g_return_if_fail (self != NULL);
	PLANK_SERIALIZABLE_GET_INTERFACE (self)->deserialize (self, s);
}


static void
plank_serializable_default_init (PlankSerializableIface * iface)
{
}


/**
 * This interface is used by objects that need to be serialized in a Preferences.
 * The object must have a string representation and provide these methods to
 * translate between the string and object representations.
 */
GType
plank_serializable_get_type (void)
{
	static volatile gsize plank_serializable_type_id__volatile = 0;
	if (g_once_init_enter (&plank_serializable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankSerializableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_serializable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType plank_serializable_type_id;
		plank_serializable_type_id = g_type_register_static (G_TYPE_INTERFACE, "PlankSerializable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (plank_serializable_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&plank_serializable_type_id__volatile, plank_serializable_type_id);
	}
	return plank_serializable_type_id__volatile;
}


static inline gpointer
plank_preferences_get_instance_private (PlankPreferences* self)
{
	return G_STRUCT_MEMBER_P (self, PlankPreferences_private_offset);
}


static void
_plank_preferences_handle_notify_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
	plank_preferences_handle_notify ((PlankPreferences*) self, _sender, pspec);
}


/**
 * Creates a new preferences object with no backing file.
 */
PlankPreferences*
plank_preferences_construct (GType object_type)
{
	PlankPreferences * self = NULL;
	self = (PlankPreferences*) g_object_new (object_type, NULL);
	return self;
}


static void
plank_preferences_handle_notify (PlankPreferences* self,
                                 GObject* sender,
                                 GParamSpec* property)
{
	gboolean _tmp0_;
	guint _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	const gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (property != NULL);
	_tmp0_ = self->priv->read_only;
	if (_tmp0_) {
		return;
	}
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _plank_preferences_handle_notify_g_object_notify, self);
	g_object_freeze_notify ((GObject*) self);
	_tmp2_ = property->name;
	plank_logger_verbose ("property changed: %s", _tmp2_, NULL);
	self->priv->is_delayed_internal = TRUE;
	_tmp3_ = self->priv->backing_file;
	if (_tmp3_ != NULL) {
		plank_preferences_save_prefs (self);
	}
	_tmp4_ = property->name;
	plank_preferences_call_verify (self, _tmp4_);
	self->priv->is_delayed_internal = FALSE;
	_tmp7_ = self->priv->is_delayed;
	if (!_tmp7_) {
		gboolean _tmp8_;
		_tmp8_ = self->priv->is_changed;
		_tmp6_ = _tmp8_;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		GFile* _tmp9_;
		_tmp9_ = self->priv->backing_file;
		_tmp5_ = _tmp9_ != NULL;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		plank_preferences_save_prefs (self);
	}
	g_object_thaw_notify ((GObject*) self);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _plank_preferences_handle_notify_g_object_notify, self, 0);
}


static void
plank_preferences_handle_verify_notify (PlankPreferences* self,
                                        GObject* sender,
                                        GParamSpec* property)
{
	GFile* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (property != NULL);
	plank_preferences_save_prefs (self);
	_tmp0_ = self->priv->backing_file;
	if (_tmp0_ != NULL) {
		gchar* _tmp1_ = NULL;
		GFile* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp5_;
		_tmp2_ = self->priv->backing_file;
		_tmp3_ = g_file_get_path (_tmp2_);
		_tmp1_ = _tmp3_;
		if (_tmp1_ == NULL) {
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("");
			_g_free0 (_tmp1_);
			_tmp1_ = _tmp4_;
		}
		_tmp5_ = property->name;
		g_warning ("Preferences.vala:113: Key '%s' failed verification in preferences file" \
" '%s', changing value", _tmp5_, _tmp1_);
		_g_free0 (_tmp1_);
	} else {
		const gchar* _tmp6_;
		_tmp6_ = property->name;
		g_warning ("Preferences.vala:115: Key '%s' failed verification, changing value", _tmp6_);
	}
}


static void
_plank_preferences_handle_verify_notify_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
	plank_preferences_handle_verify_notify ((PlankPreferences*) self, _sender, pspec);
}


static void
plank_preferences_call_verify (PlankPreferences* self,
                               const gchar* prop)
{
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (prop != NULL);
	g_object_freeze_notify ((GObject*) self);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _plank_preferences_handle_verify_notify_g_object_notify, self, 0);
	plank_preferences_verify (self, prop);
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _plank_preferences_handle_verify_notify_g_object_notify, self);
	g_object_thaw_notify ((GObject*) self);
}


/**
 * This method will verify the value of a property.
 * If the value is wrong, this method should replace it with a sanitized value.
 *
 * @param prop the name of the property that needs verified
 */
static void
plank_preferences_real_verify (PlankPreferences* self,
                               const gchar* prop)
{
	g_return_if_fail (prop != NULL);
}


void
plank_preferences_verify (PlankPreferences* self,
                          const gchar* prop)
{
	g_return_if_fail (self != NULL);
	PLANK_PREFERENCES_GET_CLASS (self)->verify (self, prop);
}


/**
 * Resets all properties to their default values.  Called from construct and before
 * loading from the backing file.
 */
static void
plank_preferences_real_reset_properties (PlankPreferences* self)
{
	g_critical ("Type `%s' does not implement abstract method `plank_preferences_reset_properties'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void
plank_preferences_reset_properties (PlankPreferences* self)
{
	g_return_if_fail (self != NULL);
	PLANK_PREFERENCES_GET_CLASS (self)->reset_properties (self);
}


/**
 * Creates a preferences object with a backing file.
 *
 * @param file the {@link GLib.File} of the backing file for this preferences
 */
PlankPreferences*
plank_preferences_construct_with_file (GType object_type,
                                       GFile* file)
{
	PlankPreferences * self = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	self = (PlankPreferences*) g_object_new (object_type, NULL);
	plank_preferences_init_from_file (self, file);
	return self;
}


/**
 * Creates a preferences object with a backing filename.
 *
 * @param filename of the backing file for this preferences
 */
PlankPreferences*
plank_preferences_construct_with_filename (GType object_type,
                                           const gchar* filename)
{
	PlankPreferences * self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	g_return_val_if_fail (filename != NULL, NULL);
	self = (PlankPreferences*) g_object_new (object_type, NULL);
	_tmp0_ = plank_paths_get_AppConfigFolder ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_get_child (_tmp1_, filename);
	_tmp3_ = _tmp2_;
	plank_preferences_init_from_file (self, _tmp3_);
	_g_object_unref0 (_tmp3_);
	return self;
}


/**
 * Initializes this preferences with a backing file.
 *
 * @param file the {@link GLib.File} of the backing file for this preferences
 */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void
plank_preferences_init_from_file (PlankPreferences* self,
                                  GFile* file)
{
	GFile* _tmp0_;
	gboolean file_exists = FALSE;
	GFile* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp22_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	plank_preferences_stop_monitor (self);
	_tmp0_ = _g_object_ref0 (file);
	_g_object_unref0 (self->priv->backing_file);
	self->priv->backing_file = _tmp0_;
	_tmp1_ = self->priv->backing_file;
	file_exists = g_file_query_exists (_tmp1_, NULL);
	_tmp2_ = self->priv->read_only;
	if (!_tmp2_) {
		{
			GFileInfo* info = NULL;
			gboolean _tmp3_;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp14_;
			gboolean _tmp16_;
			_tmp3_ = file_exists;
			if (_tmp3_) {
				GFileInfo* _tmp4_ = NULL;
				GFileInfo* _tmp5_;
				GFileInfo* _tmp6_;
				_tmp5_ = g_file_query_info (file, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
				_tmp4_ = _tmp5_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (info);
					goto __catch47_g_error;
				}
				_tmp6_ = _tmp4_;
				_tmp4_ = NULL;
				_g_object_unref0 (info);
				info = _tmp6_;
				_g_object_unref0 (_tmp4_);
			} else {
				GFileInfo* _tmp7_ = NULL;
				GFile* _tmp8_;
				GFile* _tmp9_;
				GFileInfo* _tmp10_;
				GFileInfo* _tmp11_;
				GFileInfo* _tmp12_;
				_tmp8_ = g_file_get_parent (file);
				_tmp9_ = _tmp8_;
				_tmp10_ = g_file_query_info (_tmp9_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
				_tmp11_ = _tmp10_;
				_g_object_unref0 (_tmp9_);
				_tmp7_ = _tmp11_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (info);
					goto __catch47_g_error;
				}
				_tmp12_ = _tmp7_;
				_tmp7_ = NULL;
				_g_object_unref0 (info);
				info = _tmp12_;
				_g_object_unref0 (_tmp7_);
			}
			_tmp14_ = self->priv->read_only;
			if (_tmp14_) {
				_tmp13_ = TRUE;
			} else {
				GFileInfo* _tmp15_;
				_tmp15_ = info;
				_tmp13_ = !g_file_info_get_attribute_boolean (_tmp15_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE);
			}
			self->priv->read_only = _tmp13_;
			_tmp16_ = self->priv->read_only;
			if (_tmp16_) {
				gchar* _tmp17_ = NULL;
				gchar* _tmp18_;
				_tmp18_ = g_file_get_path (file);
				_tmp17_ = _tmp18_;
				if (_tmp17_ == NULL) {
					gchar* _tmp19_;
					_tmp19_ = g_strdup ("");
					_g_free0 (_tmp17_);
					_tmp17_ = _tmp19_;
				}
				g_warning ("Preferences.vala:192: '%s' is read-only!", _tmp17_);
				_g_free0 (_tmp17_);
			}
			_g_object_unref0 (info);
		}
		goto __finally47;
		__catch47_g_error:
		{
			GError* e = NULL;
			GError* _tmp20_;
			const gchar* _tmp21_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp20_ = e;
			_tmp21_ = _tmp20_->message;
			g_warning ("Preferences.vala:194: %s", _tmp21_);
			self->priv->read_only = TRUE;
			_g_error_free0 (e);
		}
		__finally47:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp22_ = file_exists;
	if (!_tmp22_) {
		plank_preferences_save_prefs (self);
	} else {
		plank_preferences_load_prefs (self);
	}
	plank_preferences_start_monitor (self);
}


/**
 * Initializes this preferences with a backing filename.
 *
 * @param filename of the backing file for this preferences
 */
void
plank_preferences_init_from_filename (PlankPreferences* self,
                                      const gchar* filename)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (filename != NULL);
	_tmp0_ = plank_paths_get_AppConfigFolder ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_get_child (_tmp1_, filename);
	_tmp3_ = _tmp2_;
	plank_preferences_init_from_file (self, _tmp3_);
	_g_object_unref0 (_tmp3_);
}


/**
 * Delays saving changes to the backing file until apply() is called.
 */
void
plank_preferences_delay (PlankPreferences* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->read_only;
	if (_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->is_delayed;
	if (_tmp1_) {
		return;
	}
	_tmp3_ = self->priv->backing_file;
	if (_tmp3_ != NULL) {
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = self->priv->backing_file;
		_tmp5_ = g_file_get_path (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp2_ = _tmp6_ != NULL;
		_g_free0 (_tmp6_);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		GFile* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp7_ = self->priv->backing_file;
		_tmp8_ = g_file_get_path (_tmp7_);
		_tmp9_ = _tmp8_;
		plank_logger_verbose ("Preferences.delay('%s')", _tmp9_, NULL);
		_g_free0 (_tmp9_);
	} else {
		plank_logger_verbose ("Preferences.delay()", NULL);
	}
	self->priv->is_delayed = TRUE;
}


/**
 * If any settings were changed, apply them now.
 */
void
plank_preferences_apply (PlankPreferences* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->read_only;
	if (_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->is_delayed;
	if (!_tmp1_) {
		return;
	}
	_tmp3_ = self->priv->backing_file;
	if (_tmp3_ != NULL) {
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = self->priv->backing_file;
		_tmp5_ = g_file_get_path (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp2_ = _tmp6_ != NULL;
		_g_free0 (_tmp6_);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		GFile* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp7_ = self->priv->backing_file;
		_tmp8_ = g_file_get_path (_tmp7_);
		_tmp9_ = _tmp8_;
		plank_logger_verbose ("Preferences.apply('%s')", _tmp9_, NULL);
		_g_free0 (_tmp9_);
	} else {
		plank_logger_verbose ("Preferences.apply()", NULL);
	}
	self->priv->is_delayed = FALSE;
	_tmp11_ = self->priv->is_changed;
	if (_tmp11_) {
		GFile* _tmp12_;
		_tmp12_ = self->priv->backing_file;
		_tmp10_ = _tmp12_ != NULL;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		plank_preferences_save_prefs (self);
	}
}


/**
 * Returns the filename of the backing file.
 *
 * @return the filename of the backing file
 */
gchar*
plank_preferences_get_filename (PlankPreferences* self)
{
	gchar* result = NULL;
	GFile* _tmp0_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->backing_file;
	if (_tmp0_ == NULL) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("");
		result = _tmp1_;
		return result;
	}
	_tmp2_ = self->priv->backing_file;
	_tmp3_ = g_file_get_basename (_tmp2_);
	result = _tmp3_;
	return result;
}


/**
 * Returns the backing file.
 *
 * @return the backing file
 */
GFile*
plank_preferences_get_backing_file (PlankPreferences* self)
{
	GFile* result = NULL;
	GFile* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->backing_file;
	result = _tmp0_;
	return result;
}


/**
 * This forces the deletion of the backing file for this preferences.
 */
void
plank_preferences_delete (PlankPreferences* self)
{
	gboolean _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->read_only;
	if (_tmp0_) {
		return;
	}
	self->priv->is_delayed = FALSE;
	self->priv->is_changed = FALSE;
	{
		gchar* _tmp1_ = NULL;
		GFile* _tmp2_;
		gchar* _tmp3_;
		GFile* _tmp5_;
		_tmp2_ = self->priv->backing_file;
		_tmp3_ = g_file_get_path (_tmp2_);
		_tmp1_ = _tmp3_;
		if (_tmp1_ == NULL) {
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("");
			_g_free0 (_tmp1_);
			_tmp1_ = _tmp4_;
		}
		plank_logger_verbose ("Preferences.delete ('%s')", _tmp1_, NULL);
		_tmp5_ = self->priv->backing_file;
		g_file_delete (_tmp5_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			goto __catch48_g_error;
		}
		_g_free0 (_tmp1_);
	}
	goto __finally48;
	__catch48_g_error:
	{
		GError* e = NULL;
		gchar* _tmp6_ = NULL;
		GFile* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp10_;
		const gchar* _tmp11_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = self->priv->backing_file;
		_tmp8_ = g_file_get_path (_tmp7_);
		_tmp6_ = _tmp8_;
		if (_tmp6_ == NULL) {
			gchar* _tmp9_;
			_tmp9_ = g_strdup ("");
			_g_free0 (_tmp6_);
			_tmp6_ = _tmp9_;
		}
		g_warning ("Preferences.vala:300: Unable to delete the preferences file '%s'", _tmp6_);
		_tmp10_ = e;
		_tmp11_ = _tmp10_->message;
		g_debug ("Preferences.vala:301: %s", _tmp11_);
		_g_free0 (_tmp6_);
		_g_error_free0 (e);
	}
	__finally48:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}


static void
_plank_preferences_backing_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                                GFile* file,
                                                                GFile* other_file,
                                                                GFileMonitorEvent event_type,
                                                                gpointer self)
{
	plank_preferences_backing_file_changed (file, other_file, event_type, (PlankPreferences*) self);
}


static void
plank_preferences_stop_monitor (PlankPreferences* self)
{
	GFileMonitor* _tmp0_;
	GFileMonitor* _tmp1_;
	guint _tmp2_;
	GFileMonitor* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->backing_monitor;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->backing_monitor;
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp2_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _plank_preferences_backing_file_changed_g_file_monitor_changed, self);
	_tmp3_ = self->priv->backing_monitor;
	g_file_monitor_cancel (_tmp3_);
	_g_object_unref0 (self->priv->backing_monitor);
	self->priv->backing_monitor = NULL;
}


static void
plank_preferences_start_monitor (PlankPreferences* self)
{
	GFileMonitor* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->backing_monitor;
	if (_tmp0_ != NULL) {
		return;
	}
	{
		GFileMonitor* _tmp1_ = NULL;
		GFile* _tmp2_;
		GFileMonitor* _tmp3_;
		GFileMonitor* _tmp4_;
		GFileMonitor* _tmp5_;
		_tmp2_ = self->priv->backing_file;
		_tmp3_ = g_file_monitor_file (_tmp2_, 0, NULL, &_inner_error0_);
		_tmp1_ = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch49_g_error;
		}
		_tmp4_ = _tmp1_;
		_tmp1_ = NULL;
		_g_object_unref0 (self->priv->backing_monitor);
		self->priv->backing_monitor = _tmp4_;
		_tmp5_ = self->priv->backing_monitor;
		g_signal_connect_object (_tmp5_, "changed", (GCallback) _plank_preferences_backing_file_changed_g_file_monitor_changed, self, 0);
		_g_object_unref0 (_tmp1_);
	}
	goto __finally49;
	__catch49_g_error:
	{
		GError* e = NULL;
		gchar* _tmp6_ = NULL;
		GFile* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp10_;
		const gchar* _tmp11_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = self->priv->backing_file;
		_tmp8_ = g_file_get_path (_tmp7_);
		_tmp6_ = _tmp8_;
		if (_tmp6_ == NULL) {
			gchar* _tmp9_;
			_tmp9_ = g_strdup ("");
			_g_free0 (_tmp6_);
			_tmp6_ = _tmp9_;
		}
		g_critical ("Preferences.vala:324: Unable to watch the preferences file '%s'", _tmp6_);
		_tmp10_ = e;
		_tmp11_ = _tmp10_->message;
		g_debug ("Preferences.vala:325: %s", _tmp11_);
		_g_free0 (_tmp6_);
		_g_error_free0 (e);
	}
	__finally49:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}


static void
plank_preferences_backing_file_changed (GFile* f,
                                        GFile* other,
                                        GFileMonitorEvent event,
                                        PlankPreferences* self)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (f != NULL);
	switch (event) {
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
		{
			plank_preferences_load_prefs (self);
			break;
		}
		case G_FILE_MONITOR_EVENT_DELETED:
		{
			if (!g_file_query_exists (f, NULL)) {
				g_signal_emit (self, plank_preferences_signals[PLANK_PREFERENCES_DELETED_SIGNAL], 0);
			}
			break;
		}
		default:
		{
			break;
		}
	}
}


static void
plank_preferences_load_prefs (PlankPreferences* self)
{
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* backing_file_path = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gboolean missing_keys = FALSE;
	guint _tmp6_;
	gboolean _tmp144_ = FALSE;
	gboolean _tmp145_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->backing_file;
	_tmp2_ = g_file_get_path (_tmp1_);
	_tmp0_ = _tmp2_;
	if (_tmp0_ == NULL) {
		gchar* _tmp3_;
		_tmp3_ = g_strdup ("");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp3_;
	}
	_tmp4_ = _tmp0_;
	_tmp0_ = NULL;
	backing_file_path = _tmp4_;
	_tmp5_ = backing_file_path;
	g_debug ("Preferences.vala:349: Loading preferences from file '%s'", _tmp5_);
	missing_keys = FALSE;
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp6_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _plank_preferences_handle_notify_g_object_notify, self);
	g_object_freeze_notify ((GObject*) self);
	self->priv->is_delayed_internal = TRUE;
	{
		GKeyFile* file = NULL;
		GKeyFile* _tmp7_;
		GKeyFile* _tmp8_;
		const gchar* _tmp9_;
		GParamSpec** properties = NULL;
		GObjectClass* _tmp10_;
		guint _tmp11_ = 0;
		GParamSpec** _tmp12_;
		gint properties_length1;
		gint _properties_size_;
		GParamSpec** _tmp13_;
		gint _tmp13__length1;
		_tmp7_ = g_key_file_new ();
		file = _tmp7_;
		_tmp8_ = file;
		_tmp9_ = backing_file_path;
		g_key_file_load_from_file (_tmp8_, _tmp9_, 0, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_key_file_unref0 (file);
			goto __catch50_g_error;
		}
		_tmp10_ = G_OBJECT_GET_CLASS ((GObject*) self);
		_tmp12_ = g_object_class_list_properties (_tmp10_, &_tmp11_);
		properties = _tmp12_;
		properties_length1 = _tmp11_;
		_properties_size_ = properties_length1;
		_tmp13_ = properties;
		_tmp13__length1 = properties_length1;
		{
			GParamSpec** prop_collection = NULL;
			gint prop_collection_length1 = 0;
			gint _prop_collection_size_ = 0;
			gint prop_it = 0;
			prop_collection = _tmp13_;
			prop_collection_length1 = _tmp13__length1;
			for (prop_it = 0; prop_it < _tmp13__length1; prop_it = prop_it + 1) {
				GParamSpec* prop = NULL;
				prop = prop_collection[prop_it];
				{
					const gchar* group_name = NULL;
					GParamSpec* _tmp14_;
					GType _tmp15_;
					const gchar* _tmp16_;
					const gchar* prop_name = NULL;
					GParamSpec* _tmp17_;
					const gchar* _tmp18_;
					GKeyFile* _tmp19_;
					const gchar* _tmp20_;
					gboolean _tmp31_ = FALSE;
					GKeyFile* _tmp32_;
					const gchar* _tmp33_;
					GType type = 0UL;
					GParamSpec* _tmp41_;
					GType _tmp42_;
					_tmp14_ = prop;
					_tmp15_ = _tmp14_->owner_type;
					_tmp16_ = g_type_name (_tmp15_);
					group_name = _tmp16_;
					_tmp17_ = prop;
					_tmp18_ = g_param_spec_get_name (_tmp17_);
					prop_name = _tmp18_;
					_tmp19_ = file;
					_tmp20_ = group_name;
					if (!g_key_file_has_group (_tmp19_, _tmp20_)) {
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp21_ = FALSE;
								_tmp21_ = TRUE;
								while (TRUE) {
									gint _tmp23_;
									gchar** _tmp24_;
									gint _tmp24__length1;
									gint _tmp24__length2;
									gint _tmp25_;
									const gchar* _tmp26_;
									const gchar* _tmp27_;
									if (!_tmp21_) {
										gint _tmp22_;
										_tmp22_ = i;
										i = _tmp22_ + 1;
									}
									_tmp21_ = FALSE;
									_tmp23_ = i;
									if (!(_tmp23_ < 3)) {
										break;
									}
									_tmp24_ = plank_preferences_TRANSITION_MAP;
									_tmp24__length1 = plank_preferences_TRANSITION_MAP_length1;
									_tmp24__length2 = plank_preferences_TRANSITION_MAP_length2;
									_tmp25_ = i;
									_tmp26_ = _tmp24_[(_tmp25_ * _tmp24__length2) + 1];
									_tmp27_ = group_name;
									if (g_strcmp0 (_tmp26_, _tmp27_) == 0) {
										gchar** _tmp28_;
										gint _tmp28__length1;
										gint _tmp28__length2;
										gint _tmp29_;
										const gchar* _tmp30_;
										_tmp28_ = plank_preferences_TRANSITION_MAP;
										_tmp28__length1 = plank_preferences_TRANSITION_MAP_length1;
										_tmp28__length2 = plank_preferences_TRANSITION_MAP_length2;
										_tmp29_ = i;
										_tmp30_ = _tmp28_[(_tmp29_ * _tmp28__length2) + 0];
										group_name = _tmp30_;
										missing_keys = TRUE;
										break;
									}
								}
							}
						}
					}
					_tmp32_ = file;
					_tmp33_ = group_name;
					if (!g_key_file_has_group (_tmp32_, _tmp33_)) {
						_tmp31_ = TRUE;
					} else {
						gboolean _tmp34_ = FALSE;
						GKeyFile* _tmp35_;
						const gchar* _tmp36_;
						const gchar* _tmp37_;
						_tmp35_ = file;
						_tmp36_ = group_name;
						_tmp37_ = prop_name;
						_tmp34_ = g_key_file_has_key (_tmp35_, _tmp36_, _tmp37_, &_inner_error0_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							properties = (g_free (properties), NULL);
							_g_key_file_unref0 (file);
							goto __catch50_g_error;
						}
						_tmp31_ = !_tmp34_;
					}
					if (_tmp31_) {
						const gchar* _tmp38_;
						const gchar* _tmp39_;
						const gchar* _tmp40_;
						_tmp38_ = prop_name;
						_tmp39_ = group_name;
						_tmp40_ = backing_file_path;
						g_warning ("Preferences.vala:378: Missing key '%s' for group '%s' in preferences f" \
"ile '%s' - using default value", _tmp38_, _tmp39_, _tmp40_);
						missing_keys = TRUE;
						continue;
					}
					_tmp41_ = prop;
					_tmp42_ = _tmp41_->value_type;
					type = _tmp42_;
					{
						GType _tmp43_;
						const gchar* _tmp136_;
						_tmp43_ = type;
						if (_tmp43_ == G_TYPE_INT) {
							gint old_val = 0;
							const gchar* _tmp44_;
							gint _tmp45_ = 0;
							gint new_val = 0;
							GKeyFile* _tmp46_;
							const gchar* _tmp47_;
							const gchar* _tmp48_;
							gint _tmp49_;
							gint _tmp50_;
							const gchar* _tmp51_;
							gint _tmp52_;
							_tmp44_ = prop_name;
							g_object_get ((GObject*) self, _tmp44_, &_tmp45_, NULL);
							old_val = _tmp45_;
							_tmp46_ = file;
							_tmp47_ = group_name;
							_tmp48_ = prop_name;
							new_val = g_key_file_get_integer (_tmp46_, _tmp47_, _tmp48_, &_inner_error0_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
									goto __catch51_g_key_file_error;
								}
								properties = (g_free (properties), NULL);
								_g_key_file_unref0 (file);
								_g_free0 (backing_file_path);
								_g_free0 (_tmp0_);
								g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return;
							}
							_tmp49_ = old_val;
							_tmp50_ = new_val;
							if (_tmp49_ == _tmp50_) {
								continue;
							}
							_tmp51_ = prop_name;
							_tmp52_ = new_val;
							g_object_set ((GObject*) self, _tmp51_, _tmp52_, NULL);
						} else {
							GType _tmp53_;
							_tmp53_ = type;
							if (_tmp53_ == G_TYPE_UINT) {
								guint old_val = 0U;
								const gchar* _tmp54_;
								guint _tmp55_ = 0U;
								gint _tmp56_ = 0;
								GKeyFile* _tmp57_;
								const gchar* _tmp58_;
								const gchar* _tmp59_;
								guint new_val = 0U;
								guint _tmp60_;
								guint _tmp61_;
								const gchar* _tmp62_;
								guint _tmp63_;
								_tmp54_ = prop_name;
								g_object_get ((GObject*) self, _tmp54_, &_tmp55_, NULL);
								old_val = _tmp55_;
								_tmp57_ = file;
								_tmp58_ = group_name;
								_tmp59_ = prop_name;
								_tmp56_ = g_key_file_get_integer (_tmp57_, _tmp58_, _tmp59_, &_inner_error0_);
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
									if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
										goto __catch51_g_key_file_error;
									}
									properties = (g_free (properties), NULL);
									_g_key_file_unref0 (file);
									_g_free0 (backing_file_path);
									_g_free0 (_tmp0_);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
									g_clear_error (&_inner_error0_);
									return;
								}
								new_val = (guint) _tmp56_;
								_tmp60_ = old_val;
								_tmp61_ = new_val;
								if (_tmp60_ == _tmp61_) {
									continue;
								}
								_tmp62_ = prop_name;
								_tmp63_ = new_val;
								g_object_set ((GObject*) self, _tmp62_, _tmp63_, NULL);
							} else {
								GType _tmp64_;
								_tmp64_ = type;
								if (_tmp64_ == G_TYPE_DOUBLE) {
									gdouble old_val = 0.0;
									const gchar* _tmp65_;
									gdouble _tmp66_ = 0.0;
									gdouble new_val = 0.0;
									GKeyFile* _tmp67_;
									const gchar* _tmp68_;
									const gchar* _tmp69_;
									gdouble _tmp70_;
									gdouble _tmp71_;
									const gchar* _tmp72_;
									gdouble _tmp73_;
									_tmp65_ = prop_name;
									g_object_get ((GObject*) self, _tmp65_, &_tmp66_, NULL);
									old_val = _tmp66_;
									_tmp67_ = file;
									_tmp68_ = group_name;
									_tmp69_ = prop_name;
									new_val = g_key_file_get_double (_tmp67_, _tmp68_, _tmp69_, &_inner_error0_);
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
										if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
											goto __catch51_g_key_file_error;
										}
										properties = (g_free (properties), NULL);
										_g_key_file_unref0 (file);
										_g_free0 (backing_file_path);
										_g_free0 (_tmp0_);
										g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
										g_clear_error (&_inner_error0_);
										return;
									}
									_tmp70_ = old_val;
									_tmp71_ = new_val;
									if (_tmp70_ == _tmp71_) {
										continue;
									}
									_tmp72_ = prop_name;
									_tmp73_ = new_val;
									g_object_set ((GObject*) self, _tmp72_, _tmp73_, NULL);
								} else {
									GType _tmp74_;
									_tmp74_ = type;
									if (_tmp74_ == G_TYPE_STRING) {
										gchar* old_val = NULL;
										const gchar* _tmp75_;
										gchar* _tmp76_ = NULL;
										gchar* new_val = NULL;
										GKeyFile* _tmp77_;
										const gchar* _tmp78_;
										const gchar* _tmp79_;
										gchar* _tmp80_;
										const gchar* _tmp81_;
										const gchar* _tmp82_;
										const gchar* _tmp83_;
										const gchar* _tmp84_;
										_tmp75_ = prop_name;
										g_object_get ((GObject*) self, _tmp75_, &_tmp76_, NULL);
										_g_free0 (old_val);
										old_val = _tmp76_;
										_tmp77_ = file;
										_tmp78_ = group_name;
										_tmp79_ = prop_name;
										_tmp80_ = g_key_file_get_string (_tmp77_, _tmp78_, _tmp79_, &_inner_error0_);
										new_val = _tmp80_;
										if (G_UNLIKELY (_inner_error0_ != NULL)) {
											_g_free0 (old_val);
											if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
												goto __catch51_g_key_file_error;
											}
											_g_free0 (old_val);
											properties = (g_free (properties), NULL);
											_g_key_file_unref0 (file);
											_g_free0 (backing_file_path);
											_g_free0 (_tmp0_);
											g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
											g_clear_error (&_inner_error0_);
											return;
										}
										_tmp81_ = old_val;
										_tmp82_ = new_val;
										if (g_strcmp0 (_tmp81_, _tmp82_) == 0) {
											_g_free0 (new_val);
											_g_free0 (old_val);
											continue;
										}
										_tmp83_ = prop_name;
										_tmp84_ = new_val;
										g_object_set ((GObject*) self, _tmp83_, _tmp84_, NULL);
										_g_free0 (new_val);
										_g_free0 (old_val);
									} else {
										GType _tmp85_;
										_tmp85_ = type;
										if (_tmp85_ == G_TYPE_BOOLEAN) {
											gboolean old_val = FALSE;
											const gchar* _tmp86_;
											gboolean _tmp87_ = FALSE;
											gboolean new_val = FALSE;
											GKeyFile* _tmp88_;
											const gchar* _tmp89_;
											const gchar* _tmp90_;
											gboolean _tmp91_;
											gboolean _tmp92_;
											const gchar* _tmp93_;
											gboolean _tmp94_;
											_tmp86_ = prop_name;
											g_object_get ((GObject*) self, _tmp86_, &_tmp87_, NULL);
											old_val = _tmp87_;
											_tmp88_ = file;
											_tmp89_ = group_name;
											_tmp90_ = prop_name;
											new_val = g_key_file_get_boolean (_tmp88_, _tmp89_, _tmp90_, &_inner_error0_);
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
												if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
													goto __catch51_g_key_file_error;
												}
												properties = (g_free (properties), NULL);
												_g_key_file_unref0 (file);
												_g_free0 (backing_file_path);
												_g_free0 (_tmp0_);
												g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
												g_clear_error (&_inner_error0_);
												return;
											}
											_tmp91_ = old_val;
											_tmp92_ = new_val;
											if (_tmp91_ == _tmp92_) {
												continue;
											}
											_tmp93_ = prop_name;
											_tmp94_ = new_val;
											g_object_set ((GObject*) self, _tmp93_, _tmp94_, NULL);
										} else {
											GType _tmp95_;
											_tmp95_ = type;
											if (G_TYPE_IS_ENUM (_tmp95_)) {
												gint old_val = 0;
												const gchar* _tmp96_;
												gint _tmp97_ = 0;
												gint new_val = 0;
												GKeyFile* _tmp98_;
												const gchar* _tmp99_;
												const gchar* _tmp100_;
												gint _tmp101_;
												gint _tmp102_;
												const gchar* _tmp103_;
												gint _tmp104_;
												_tmp96_ = prop_name;
												g_object_get ((GObject*) self, _tmp96_, &_tmp97_, NULL);
												old_val = _tmp97_;
												_tmp98_ = file;
												_tmp99_ = group_name;
												_tmp100_ = prop_name;
												new_val = g_key_file_get_integer (_tmp98_, _tmp99_, _tmp100_, &_inner_error0_);
												if (G_UNLIKELY (_inner_error0_ != NULL)) {
													if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
														goto __catch51_g_key_file_error;
													}
													properties = (g_free (properties), NULL);
													_g_key_file_unref0 (file);
													_g_free0 (backing_file_path);
													_g_free0 (_tmp0_);
													g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
													g_clear_error (&_inner_error0_);
													return;
												}
												_tmp101_ = old_val;
												_tmp102_ = new_val;
												if (_tmp101_ == _tmp102_) {
													continue;
												}
												_tmp103_ = prop_name;
												_tmp104_ = new_val;
												g_object_set ((GObject*) self, _tmp103_, _tmp104_, NULL);
											} else {
												gboolean _tmp105_ = FALSE;
												GType _tmp106_;
												_tmp106_ = type;
												if (g_type_is_a (_tmp106_, PLANK_TYPE_COLOR)) {
													_tmp105_ = TRUE;
												} else {
													GType _tmp107_;
													_tmp107_ = type;
													_tmp105_ = g_type_is_a (_tmp107_, gdk_rgba_get_type ());
												}
												if (_tmp105_) {
													GValue val = {0};
													GType _tmp108_;
													GValue _tmp109_ = {0};
													const gchar* _tmp110_;
													PlankColor* old_val = NULL;
													void* _tmp111_;
													gchar* old_val_string = NULL;
													gchar* _tmp112_;
													gchar* new_val_string = NULL;
													GKeyFile* _tmp113_;
													const gchar* _tmp114_;
													const gchar* _tmp115_;
													gchar* _tmp116_;
													const gchar* _tmp117_;
													const gchar* _tmp118_;
													PlankColor new_val = {0};
													const gchar* _tmp119_;
													PlankColor _tmp120_ = {0};
													const gchar* _tmp121_;
													GValue _tmp122_;
													_tmp108_ = type;
													g_value_init (&_tmp109_, _tmp108_);
													val = _tmp109_;
													_tmp110_ = prop_name;
													g_object_get_property ((GObject*) self, _tmp110_, &val);
													_tmp111_ = g_value_get_boxed (&val);
													old_val = _tmp111_;
													_tmp112_ = plank_color_to_prefs_string (old_val);
													old_val_string = _tmp112_;
													_tmp113_ = file;
													_tmp114_ = group_name;
													_tmp115_ = prop_name;
													_tmp116_ = g_key_file_get_string (_tmp113_, _tmp114_, _tmp115_, &_inner_error0_);
													new_val_string = _tmp116_;
													if (G_UNLIKELY (_inner_error0_ != NULL)) {
														_g_free0 (old_val_string);
														G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
														if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
															goto __catch51_g_key_file_error;
														}
														_g_free0 (old_val_string);
														G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
														properties = (g_free (properties), NULL);
														_g_key_file_unref0 (file);
														_g_free0 (backing_file_path);
														_g_free0 (_tmp0_);
														g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
														g_clear_error (&_inner_error0_);
														return;
													}
													_tmp117_ = old_val_string;
													_tmp118_ = new_val_string;
													if (g_strcmp0 (_tmp117_, _tmp118_) == 0) {
														_g_free0 (new_val_string);
														_g_free0 (old_val_string);
														G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
														continue;
													}
													_tmp119_ = new_val_string;
													plank_color_from_prefs_string (_tmp119_, &_tmp120_);
													new_val = _tmp120_;
													g_value_set_boxed (&val, &new_val);
													_tmp121_ = prop_name;
													_tmp122_ = val;
													g_object_set_property ((GObject*) self, _tmp121_, &_tmp122_);
													_g_free0 (new_val_string);
													_g_free0 (old_val_string);
													G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
												} else {
													GType _tmp123_;
													_tmp123_ = type;
													if (g_type_is_a (_tmp123_, PLANK_TYPE_SERIALIZABLE)) {
														PlankSerializable* val = NULL;
														const gchar* _tmp124_;
														PlankSerializable* _tmp125_ = NULL;
														gchar* _tmp126_ = NULL;
														GKeyFile* _tmp127_;
														const gchar* _tmp128_;
														const gchar* _tmp129_;
														gchar* _tmp130_;
														PlankSerializable* _tmp131_;
														_tmp124_ = prop_name;
														g_object_get ((GObject*) self, _tmp124_, &_tmp125_, NULL);
														_g_object_unref0 (val);
														val = _tmp125_;
														_tmp127_ = file;
														_tmp128_ = group_name;
														_tmp129_ = prop_name;
														_tmp130_ = g_key_file_get_string (_tmp127_, _tmp128_, _tmp129_, &_inner_error0_);
														_tmp126_ = _tmp130_;
														if (G_UNLIKELY (_inner_error0_ != NULL)) {
															_g_object_unref0 (val);
															if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
																goto __catch51_g_key_file_error;
															}
															_g_object_unref0 (val);
															properties = (g_free (properties), NULL);
															_g_key_file_unref0 (file);
															_g_free0 (backing_file_path);
															_g_free0 (_tmp0_);
															g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
															g_clear_error (&_inner_error0_);
															return;
														}
														_tmp131_ = val;
														plank_serializable_deserialize (_tmp131_, _tmp126_);
														_g_free0 (_tmp126_);
														_g_object_unref0 (val);
														continue;
													} else {
														GType _tmp132_;
														const gchar* _tmp133_;
														const gchar* _tmp134_;
														const gchar* _tmp135_;
														_tmp132_ = type;
														_tmp133_ = g_type_name (_tmp132_);
														_tmp134_ = prop_name;
														_tmp135_ = backing_file_path;
														g_debug ("Preferences.vala:445: Unsupported preferences type '%s' for property '" \
"%s' in file '%s'", _tmp133_, _tmp134_, _tmp135_);
														continue;
													}
												}
											}
										}
									}
								}
							}
						}
						_tmp136_ = prop_name;
						plank_preferences_call_verify (self, _tmp136_);
					}
					goto __finally51;
					__catch51_g_key_file_error:
					{
						GError* e = NULL;
						const gchar* _tmp137_;
						const gchar* _tmp138_;
						GError* _tmp139_;
						const gchar* _tmp140_;
						e = _inner_error0_;
						_inner_error0_ = NULL;
						_tmp137_ = backing_file_path;
						_tmp138_ = prop_name;
						g_warning ("Preferences.vala:451: Problem loading preferences from file '%s' for p" \
"roperty '%s'", _tmp137_, _tmp138_);
						_tmp139_ = e;
						_tmp140_ = _tmp139_->message;
						g_debug ("Preferences.vala:452: %s", _tmp140_);
						_g_error_free0 (e);
					}
					__finally51:
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						properties = (g_free (properties), NULL);
						_g_key_file_unref0 (file);
						goto __catch50_g_error;
					}
				}
			}
		}
		properties = (g_free (properties), NULL);
		_g_key_file_unref0 (file);
	}
	goto __finally50;
	__catch50_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp141_;
		GError* _tmp142_;
		const gchar* _tmp143_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp141_ = backing_file_path;
		g_warning ("Preferences.vala:456: Unable to load preferences from file '%s'", _tmp141_);
		_tmp142_ = e;
		_tmp143_ = _tmp142_->message;
		g_debug ("Preferences.vala:457: %s", _tmp143_);
		g_signal_emit (self, plank_preferences_signals[PLANK_PREFERENCES_DELETED_SIGNAL], 0);
		_g_error_free0 (e);
	}
	__finally50:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (backing_file_path);
		_g_free0 (_tmp0_);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	g_object_thaw_notify ((GObject*) self);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _plank_preferences_handle_notify_g_object_notify, self, 0);
	self->priv->is_delayed_internal = FALSE;
	_tmp145_ = missing_keys;
	if (_tmp145_) {
		_tmp144_ = TRUE;
	} else {
		gboolean _tmp146_ = FALSE;
		gboolean _tmp147_ = FALSE;
		gboolean _tmp148_;
		_tmp148_ = self->priv->is_delayed;
		if (!_tmp148_) {
			gboolean _tmp149_;
			_tmp149_ = self->priv->is_changed;
			_tmp147_ = _tmp149_;
		} else {
			_tmp147_ = FALSE;
		}
		if (_tmp147_) {
			GFile* _tmp150_;
			_tmp150_ = self->priv->backing_file;
			_tmp146_ = _tmp150_ != NULL;
		} else {
			_tmp146_ = FALSE;
		}
		_tmp144_ = _tmp146_;
	}
	if (_tmp144_) {
		plank_preferences_save_prefs (self);
	}
	_g_free0 (backing_file_path);
	_g_free0 (_tmp0_);
}


static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
	result = _tmp0_;
	return result;
}


static void
plank_preferences_save_prefs (PlankPreferences* self)
{
	GFile* _tmp0_;
	gboolean _tmp1_;
	gchar* _tmp2_ = NULL;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* backing_file_path = NULL;
	gchar* _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_;
	GKeyFile* file = NULL;
	GKeyFile* _tmp11_;
	GParamSpec** properties = NULL;
	GObjectClass* _tmp19_;
	guint _tmp20_ = 0;
	GParamSpec** _tmp21_;
	gint properties_length1;
	gint _properties_size_;
	GParamSpec** _tmp22_;
	gint _tmp22__length1;
	const gchar* _tmp110_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->backing_file;
	_vala_return_if_fail (_tmp0_ != NULL, "backing_file != null");
	_tmp1_ = self->priv->read_only;
	if (_tmp1_) {
		return;
	}
	_tmp3_ = self->priv->backing_file;
	_tmp4_ = g_file_get_path (_tmp3_);
	_tmp2_ = _tmp4_;
	if (_tmp2_ == NULL) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup ("");
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp5_;
	}
	_tmp6_ = _tmp2_;
	_tmp2_ = NULL;
	backing_file_path = _tmp6_;
	_tmp8_ = self->priv->is_delayed;
	if (_tmp8_) {
		_tmp7_ = TRUE;
	} else {
		gboolean _tmp9_;
		_tmp9_ = self->priv->is_delayed_internal;
		_tmp7_ = _tmp9_;
	}
	if (_tmp7_) {
		const gchar* _tmp10_;
		_tmp10_ = backing_file_path;
		plank_logger_verbose ("Preferences.save_prefs('%s') - delaying save", _tmp10_, NULL);
		self->priv->is_changed = TRUE;
		_g_free0 (backing_file_path);
		_g_free0 (_tmp2_);
		return;
	}
	plank_preferences_stop_monitor (self);
	g_object_freeze_notify ((GObject*) self);
	_tmp11_ = g_key_file_new ();
	file = _tmp11_;
	{
		GKeyFile* _tmp12_;
		GDateTime* _tmp13_;
		GDateTime* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		_tmp12_ = file;
		_tmp13_ = g_date_time_new_now_utc ();
		_tmp14_ = _tmp13_;
		_tmp15_ = g_date_time_to_string (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = g_strdup_printf ("This file auto-generated by Plank.\n%s", _tmp16_);
		_tmp18_ = _tmp17_;
		g_key_file_set_comment (_tmp12_, NULL, NULL, _tmp18_, &_inner_error0_);
		_g_free0 (_tmp18_);
		_g_free0 (_tmp16_);
		_g_date_time_unref0 (_tmp14_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch52_g_error;
		}
	}
	goto __finally52;
	__catch52_g_error:
	{
		g_clear_error (&_inner_error0_);
		_inner_error0_ = NULL;
	}
	__finally52:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_key_file_unref0 (file);
		_g_free0 (backing_file_path);
		_g_free0 (_tmp2_);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp19_ = G_OBJECT_GET_CLASS ((GObject*) self);
	_tmp21_ = g_object_class_list_properties (_tmp19_, &_tmp20_);
	properties = _tmp21_;
	properties_length1 = _tmp20_;
	_properties_size_ = properties_length1;
	_tmp22_ = properties;
	_tmp22__length1 = properties_length1;
	{
		GParamSpec** prop_collection = NULL;
		gint prop_collection_length1 = 0;
		gint _prop_collection_size_ = 0;
		gint prop_it = 0;
		prop_collection = _tmp22_;
		prop_collection_length1 = _tmp22__length1;
		for (prop_it = 0; prop_it < _tmp22__length1; prop_it = prop_it + 1) {
			GParamSpec* prop = NULL;
			prop = prop_collection[prop_it];
			{
				const gchar* group_name = NULL;
				GParamSpec* _tmp23_;
				GType _tmp24_;
				const gchar* _tmp25_;
				const gchar* prop_name = NULL;
				GParamSpec* _tmp26_;
				const gchar* _tmp27_;
				GType type = 0UL;
				GParamSpec* _tmp28_;
				GType _tmp29_;
				GType _tmp30_;
				const gchar* prop_blurb = NULL;
				GParamSpec* _tmp98_;
				const gchar* _tmp99_;
				gboolean _tmp100_ = FALSE;
				gboolean _tmp101_ = FALSE;
				const gchar* _tmp102_;
				_tmp23_ = prop;
				_tmp24_ = _tmp23_->owner_type;
				_tmp25_ = g_type_name (_tmp24_);
				group_name = _tmp25_;
				_tmp26_ = prop;
				_tmp27_ = g_param_spec_get_name (_tmp26_);
				prop_name = _tmp27_;
				_tmp28_ = prop;
				_tmp29_ = _tmp28_->value_type;
				type = _tmp29_;
				_tmp30_ = type;
				if (_tmp30_ == G_TYPE_INT) {
					gint new_val = 0;
					const gchar* _tmp31_;
					gint _tmp32_ = 0;
					GKeyFile* _tmp33_;
					const gchar* _tmp34_;
					const gchar* _tmp35_;
					gint _tmp36_;
					_tmp31_ = prop_name;
					g_object_get ((GObject*) self, _tmp31_, &_tmp32_, NULL);
					new_val = _tmp32_;
					_tmp33_ = file;
					_tmp34_ = group_name;
					_tmp35_ = prop_name;
					_tmp36_ = new_val;
					g_key_file_set_integer (_tmp33_, _tmp34_, _tmp35_, _tmp36_);
				} else {
					GType _tmp37_;
					_tmp37_ = type;
					if (_tmp37_ == G_TYPE_UINT) {
						guint new_val = 0U;
						const gchar* _tmp38_;
						guint _tmp39_ = 0U;
						GKeyFile* _tmp40_;
						const gchar* _tmp41_;
						const gchar* _tmp42_;
						guint _tmp43_;
						_tmp38_ = prop_name;
						g_object_get ((GObject*) self, _tmp38_, &_tmp39_, NULL);
						new_val = _tmp39_;
						_tmp40_ = file;
						_tmp41_ = group_name;
						_tmp42_ = prop_name;
						_tmp43_ = new_val;
						g_key_file_set_integer (_tmp40_, _tmp41_, _tmp42_, (gint) _tmp43_);
					} else {
						GType _tmp44_;
						_tmp44_ = type;
						if (_tmp44_ == G_TYPE_DOUBLE) {
							gdouble new_val = 0.0;
							const gchar* _tmp45_;
							gdouble _tmp46_ = 0.0;
							GKeyFile* _tmp47_;
							const gchar* _tmp48_;
							const gchar* _tmp49_;
							gdouble _tmp50_;
							_tmp45_ = prop_name;
							g_object_get ((GObject*) self, _tmp45_, &_tmp46_, NULL);
							new_val = _tmp46_;
							_tmp47_ = file;
							_tmp48_ = group_name;
							_tmp49_ = prop_name;
							_tmp50_ = new_val;
							g_key_file_set_double (_tmp47_, _tmp48_, _tmp49_, _tmp50_);
						} else {
							GType _tmp51_;
							_tmp51_ = type;
							if (_tmp51_ == G_TYPE_STRING) {
								gchar* new_val = NULL;
								const gchar* _tmp52_;
								gchar* _tmp53_ = NULL;
								GKeyFile* _tmp54_;
								const gchar* _tmp55_;
								const gchar* _tmp56_;
								const gchar* _tmp57_;
								_tmp52_ = prop_name;
								g_object_get ((GObject*) self, _tmp52_, &_tmp53_, NULL);
								_g_free0 (new_val);
								new_val = _tmp53_;
								_tmp54_ = file;
								_tmp55_ = group_name;
								_tmp56_ = prop_name;
								_tmp57_ = new_val;
								g_key_file_set_string (_tmp54_, _tmp55_, _tmp56_, _tmp57_);
								_g_free0 (new_val);
							} else {
								GType _tmp58_;
								_tmp58_ = type;
								if (_tmp58_ == G_TYPE_BOOLEAN) {
									gboolean new_val = FALSE;
									const gchar* _tmp59_;
									gboolean _tmp60_ = FALSE;
									GKeyFile* _tmp61_;
									const gchar* _tmp62_;
									const gchar* _tmp63_;
									gboolean _tmp64_;
									_tmp59_ = prop_name;
									g_object_get ((GObject*) self, _tmp59_, &_tmp60_, NULL);
									new_val = _tmp60_;
									_tmp61_ = file;
									_tmp62_ = group_name;
									_tmp63_ = prop_name;
									_tmp64_ = new_val;
									g_key_file_set_boolean (_tmp61_, _tmp62_, _tmp63_, _tmp64_);
								} else {
									GType _tmp65_;
									_tmp65_ = type;
									if (G_TYPE_IS_ENUM (_tmp65_)) {
										gint new_val = 0;
										const gchar* _tmp66_;
										gint _tmp67_ = 0;
										GKeyFile* _tmp68_;
										const gchar* _tmp69_;
										const gchar* _tmp70_;
										gint _tmp71_;
										_tmp66_ = prop_name;
										g_object_get ((GObject*) self, _tmp66_, &_tmp67_, NULL);
										new_val = _tmp67_;
										_tmp68_ = file;
										_tmp69_ = group_name;
										_tmp70_ = prop_name;
										_tmp71_ = new_val;
										g_key_file_set_integer (_tmp68_, _tmp69_, _tmp70_, _tmp71_);
									} else {
										gboolean _tmp72_ = FALSE;
										GType _tmp73_;
										_tmp73_ = type;
										if (g_type_is_a (_tmp73_, PLANK_TYPE_COLOR)) {
											_tmp72_ = TRUE;
										} else {
											GType _tmp74_;
											_tmp74_ = type;
											_tmp72_ = g_type_is_a (_tmp74_, gdk_rgba_get_type ());
										}
										if (_tmp72_) {
											GValue val = {0};
											GType _tmp75_;
											GValue _tmp76_ = {0};
											const gchar* _tmp77_;
											PlankColor* color = NULL;
											void* _tmp78_;
											GKeyFile* _tmp79_;
											const gchar* _tmp80_;
											const gchar* _tmp81_;
											gchar* _tmp82_;
											gchar* _tmp83_;
											_tmp75_ = type;
											g_value_init (&_tmp76_, _tmp75_);
											val = _tmp76_;
											_tmp77_ = prop_name;
											g_object_get_property ((GObject*) self, _tmp77_, &val);
											_tmp78_ = g_value_get_boxed (&val);
											color = _tmp78_;
											_tmp79_ = file;
											_tmp80_ = group_name;
											_tmp81_ = prop_name;
											_tmp82_ = plank_color_to_prefs_string (color);
											_tmp83_ = _tmp82_;
											g_key_file_set_string (_tmp79_, _tmp80_, _tmp81_, _tmp83_);
											_g_free0 (_tmp83_);
											G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
										} else {
											GType _tmp84_;
											_tmp84_ = type;
											if (g_type_is_a (_tmp84_, PLANK_TYPE_SERIALIZABLE)) {
												GValue val = {0};
												GType _tmp85_;
												GValue _tmp86_ = {0};
												const gchar* _tmp87_;
												GKeyFile* _tmp88_;
												const gchar* _tmp89_;
												const gchar* _tmp90_;
												GObject* _tmp91_;
												gchar* _tmp92_;
												gchar* _tmp93_;
												_tmp85_ = type;
												g_value_init (&_tmp86_, _tmp85_);
												val = _tmp86_;
												_tmp87_ = prop_name;
												g_object_get_property ((GObject*) self, _tmp87_, &val);
												_tmp88_ = file;
												_tmp89_ = group_name;
												_tmp90_ = prop_name;
												_tmp91_ = g_value_get_object (&val);
												_tmp92_ = plank_serializable_serialize (G_TYPE_CHECK_INSTANCE_CAST (_tmp91_, PLANK_TYPE_SERIALIZABLE, PlankSerializable));
												_tmp93_ = _tmp92_;
												g_key_file_set_string (_tmp88_, _tmp89_, _tmp90_, _tmp93_);
												_g_free0 (_tmp93_);
												G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
											} else {
												GType _tmp94_;
												const gchar* _tmp95_;
												const gchar* _tmp96_;
												const gchar* _tmp97_;
												_tmp94_ = type;
												_tmp95_ = g_type_name (_tmp94_);
												_tmp96_ = prop_name;
												_tmp97_ = backing_file_path;
												g_debug ("Preferences.vala:534: Unsupported preferences type '%s' for property '" \
"%s' in file '%s'", _tmp95_, _tmp96_, _tmp97_);
												continue;
											}
										}
									}
								}
							}
						}
					}
				}
				_tmp98_ = prop;
				_tmp99_ = g_param_spec_get_blurb (_tmp98_);
				prop_blurb = _tmp99_;
				_tmp102_ = prop_blurb;
				if (_tmp102_ != NULL) {
					const gchar* _tmp103_;
					_tmp103_ = prop_blurb;
					_tmp101_ = g_strcmp0 (_tmp103_, "") != 0;
				} else {
					_tmp101_ = FALSE;
				}
				if (_tmp101_) {
					const gchar* _tmp104_;
					const gchar* _tmp105_;
					_tmp104_ = prop_blurb;
					_tmp105_ = prop_name;
					_tmp100_ = g_strcmp0 (_tmp104_, _tmp105_) != 0;
				} else {
					_tmp100_ = FALSE;
				}
				if (_tmp100_) {
					{
						GKeyFile* _tmp106_;
						const gchar* _tmp107_;
						const gchar* _tmp108_;
						const gchar* _tmp109_;
						_tmp106_ = file;
						_tmp107_ = group_name;
						_tmp108_ = prop_name;
						_tmp109_ = prop_blurb;
						g_key_file_set_comment (_tmp106_, _tmp107_, _tmp108_, _tmp109_, &_inner_error0_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							goto __catch53_g_error;
						}
					}
					goto __finally53;
					__catch53_g_error:
					{
						g_clear_error (&_inner_error0_);
						_inner_error0_ = NULL;
					}
					__finally53:
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						properties = (g_free (properties), NULL);
						_g_key_file_unref0 (file);
						_g_free0 (backing_file_path);
						_g_free0 (_tmp2_);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
			}
		}
	}
	_tmp110_ = backing_file_path;
	g_debug ("Preferences.vala:545: Saving preferences '%s'", _tmp110_);
	self->priv->is_changed = FALSE;
	{
		GFileOutputStream* _tmp111_ = NULL;
		GFile* _tmp112_;
		GFileOutputStream* _tmp113_;
		GDataOutputStream* stream = NULL;
		GDataOutputStream* _tmp114_;
		GDataOutputStream* _tmp115_;
		GKeyFile* _tmp116_;
		gchar* _tmp117_;
		gchar* _tmp118_;
		GDataOutputStream* _tmp119_;
		_tmp112_ = self->priv->backing_file;
		_tmp113_ = g_file_replace (_tmp112_, NULL, FALSE, 0, NULL, &_inner_error0_);
		_tmp111_ = _tmp113_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch54_g_error;
		}
		_tmp114_ = g_data_output_stream_new ((GOutputStream*) _tmp111_);
		stream = _tmp114_;
		_tmp115_ = stream;
		_tmp116_ = file;
		_tmp117_ = g_key_file_to_data (_tmp116_, NULL, NULL);
		_tmp118_ = _tmp117_;
		g_data_output_stream_put_string (_tmp115_, _tmp118_, NULL, &_inner_error0_);
		_g_free0 (_tmp118_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (stream);
			_g_object_unref0 (_tmp111_);
			goto __catch54_g_error;
		}
		_tmp119_ = stream;
		g_output_stream_close ((GOutputStream*) _tmp119_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (stream);
			_g_object_unref0 (_tmp111_);
			goto __catch54_g_error;
		}
		_g_object_unref0 (stream);
		_g_object_unref0 (_tmp111_);
	}
	goto __finally54;
	__catch54_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp120_;
		GError* _tmp121_;
		const gchar* _tmp122_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp120_ = backing_file_path;
		g_warning ("Preferences.vala:553: Unable to create the preferences file '%s'", _tmp120_);
		_tmp121_ = e;
		_tmp122_ = _tmp121_->message;
		g_debug ("Preferences.vala:554: %s", _tmp122_);
		_g_error_free0 (e);
	}
	__finally54:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		properties = (g_free (properties), NULL);
		_g_key_file_unref0 (file);
		_g_free0 (backing_file_path);
		_g_free0 (_tmp2_);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	g_object_thaw_notify ((GObject*) self);
	plank_preferences_start_monitor (self);
	properties = (g_free (properties), NULL);
	_g_key_file_unref0 (file);
	_g_free0 (backing_file_path);
	_g_free0 (_tmp2_);
}


static GObject *
plank_preferences_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankPreferences * self;
	parent_class = G_OBJECT_CLASS (plank_preferences_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_PREFERENCES, PlankPreferences);
	plank_preferences_reset_properties (self);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _plank_preferences_handle_notify_g_object_notify, self, 0);
	return obj;
}


static void
plank_preferences_class_init (PlankPreferencesClass * klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar** _tmp6_;
	plank_preferences_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PlankPreferences_private_offset);
	((PlankPreferencesClass *) klass)->verify = (void (*) (PlankPreferences*, const gchar*)) plank_preferences_real_verify;
	((PlankPreferencesClass *) klass)->reset_properties = (void (*) (PlankPreferences*)) plank_preferences_real_reset_properties;
	G_OBJECT_CLASS (klass)->constructor = plank_preferences_constructor;
	G_OBJECT_CLASS (klass)->finalize = plank_preferences_finalize;
	/**
	 * This signal indicates that the backing file for this preferences was deleted.
	 */
	plank_preferences_signals[PLANK_PREFERENCES_DELETED_SIGNAL] = g_signal_new ("deleted", PLANK_TYPE_PREFERENCES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	_tmp0_ = g_strdup ("PlankItemsDockItemPreferences");
	_tmp1_ = g_strdup ("PlankDockItemPreferences");
	_tmp2_ = g_strdup ("PlankDrawingTheme");
	_tmp3_ = g_strdup ("PlankTheme");
	_tmp4_ = g_strdup ("PlankDrawingDockTheme");
	_tmp5_ = g_strdup ("PlankDockTheme");
	_tmp6_ = g_new0 (gchar*, (3 * 2) + 1);
	_tmp6_[0] = _tmp0_;
	_tmp6_[1] = _tmp1_;
	_tmp6_[2] = _tmp2_;
	_tmp6_[3] = _tmp3_;
	_tmp6_[4] = _tmp4_;
	_tmp6_[5] = _tmp5_;
	plank_preferences_TRANSITION_MAP = _tmp6_;
	plank_preferences_TRANSITION_MAP_length1 = 3;
	plank_preferences_TRANSITION_MAP_length2 = 2;
}


static void
plank_preferences_instance_init (PlankPreferences * self)
{
	self->priv = plank_preferences_get_instance_private (self);
	self->priv->read_only = FALSE;
	self->priv->is_delayed = FALSE;
	self->priv->is_delayed_internal = FALSE;
	self->priv->is_changed = FALSE;
}


static void
plank_preferences_finalize (GObject * obj)
{
	PlankPreferences * self;
	guint _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_PREFERENCES, PlankPreferences);
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _plank_preferences_handle_notify_g_object_notify, self);
	plank_preferences_apply (self);
	plank_preferences_stop_monitor (self);
	_g_object_unref0 (self->priv->backing_file);
	_g_object_unref0 (self->priv->backing_monitor);
	G_OBJECT_CLASS (plank_preferences_parent_class)->finalize (obj);
}


/**
 * The base class for all preferences in the system.  Preferences are serialized to files.
 * The file is watched for changes and loads new values if the backing file changed.  When
 * any public property of a sub-class is changed, the public properties are serialized to
 * the backing file.
 */
GType
plank_preferences_get_type (void)
{
	static volatile gsize plank_preferences_type_id__volatile = 0;
	if (g_once_init_enter (&plank_preferences_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankPreferencesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_preferences_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankPreferences), 0, (GInstanceInitFunc) plank_preferences_instance_init, NULL };
		GType plank_preferences_type_id;
		plank_preferences_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankPreferences", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		PlankPreferences_private_offset = g_type_add_instance_private (plank_preferences_type_id, sizeof (PlankPreferencesPrivate));
		g_once_init_leave (&plank_preferences_type_id__volatile, plank_preferences_type_id);
	}
	return plank_preferences_type_id__volatile;
}



